/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.24 from the
 * contents of SSH2.xs. Do not edit this file, edit SSH2.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "SSH2.xs"
/*
 * SSH2.xs - C functions for Net::SSH2
 *
 * D. Robins, 20051022
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#define NEED_sv_2pv_flags
#define NEED_newRV_noinc
#define NEED_sv_2pv_nolen
#include "ppport.h"

#include <libssh2.h>
#include <libssh2_sftp.h>
#include <libssh2_publickey.h>


#include "const-c.inc"

#if defined(USE_ITHREADS) && (defined(I_PTHREAD) || defined(WIN32))

#ifdef USE_GCRYPT
#define HAVE_GCRYPT
#include <gcrypt.h>
#else /* OpenSSL */
#define HAVE_OPENSSL
#include <openssl/crypto.h>
#endif

#else
/* is #warning portable across C compilers? */
/* NO, an error with -pedantic */
/* #warning "Building a non-threadsafe Net::SSH2" */
#endif

#ifndef MULTIPLICITY
/* for debugging output */
#define my_perl ((void *)0)
#endif

/* constants */

#ifndef LIBSSH2_ERROR_NONE
#define LIBSSH2_ERROR_NONE 0
#endif  /* LIBSSH2_ERROR_NONE */

/* LIBSSH2_ERROR_* values; from 0 continuing negative */
static const char *const xs_libssh2_error[] = {
    "NONE",
    "SOCKET_NONE",
    "BANNER_NONE",
    "BANNER_SEND",
    "INVALID_MAC",
    "KEX_FAILURE",
    "ALLOC",
    "SOCKET_SEND",
    "KEY_EXCHANGE_FAILURE",
    "TIMEOUT",
    "HOSTKEY_INIT",
    "HOSTKEY_SIGN",
    "DECRYPT",
    "SOCKET_DISCONNECT",
    "PROTO",
    "PASSWORD_EXPIRED",
    "FILE",
    "METHOD_NONE",
    "PUBLICKEY_UNRECOGNIZED",
    "PUBLICKEY_UNVERIFIED",
    "CHANNEL_OUTOFORDER",
    "CHANNEL_FAILURE",
    "CHANNEL_REQUEST_DENIED",
    "CHANNEL_UNKNOWN",
    "CHANNEL_WINDOW_EXCEEDED",
    "CHANNEL_PACKET_EXCEEDED",
    "CHANNEL_CLOSED",
    "CHANNEL_EOF_SENT",
    "SCP_PROTOCOL",
    "ZLIB",
    "SOCKET_TIMEOUT",
    "SFTP_PROTOCOL",
    "REQUEST_DENIED",
    "METHOD_NOT_SUPPORTED",
    "INVAL",
    "INVALID_POLL_TYPE",
	"PUBLICKEY_PROTOCOL",
    "EAGAIN"
};

/* SSH_FX_* values; from 0 continuing positive */
static const char *const sftp_error[] = {
    "OK",
    "EOF",
    "NO_SUCH_FILE",
    "PERMISSION_DENIED",
    "FAILURE",
    "BAD_MESSAGE",
    "NO_CONNECTION",
    "CONNECTION_LOST",
    "OP_UNSUPPORTED",
    "INVALID_HANDLE",
    "NO_SUCH_PATH",
    "FILE_ALREADY_EXISTS",
    "WRITE_PROTECT",
    "NO_MEDIA",
    "NO_SPACE_ON_FILESYSTEM",
    "QUOTA_EXCEEDED",
    "UNKNOWN_PRINCIPLE",
    "LOCK_CONFLICT",
    "DIR_NOT_EMPTY",
    "NOT_A_DIRECTORY",
    "INVALID_FILENAME",
    "LINK_LOOP"
};

/* private internal functions */

#define countof(x) (sizeof(x)/sizeof(*x))

#define XLATEXT (SvTRUE(ext) ? SSH_EXTENDED_DATA_STDERR : 0)

#define XLATATTR(name, field, flag) \
    else if (strEQ(key, name)) { \
        attrs.field = SvUV(ST(i + 1)); \
        attrs.flags |= LIBSSH2_SFTP_ATTR_##flag; \
    }

/* Net::SSH2 object */
typedef struct SSH2 {
    LIBSSH2_SESSION* session;
    SV* sv_ss;  /* NB: not set until callback() called */
    SV* socket;
    SV* sv_tmp;
    int errcode;
    SV* errmsg;
    SV* rgsv_cb[LIBSSH2_CALLBACK_X11 + 1];
} SSH2;

/* Net::SSH2::Channel object */
typedef struct SSH2_CHANNEL {
    SSH2* ss;
    SV* sv_ss;
    LIBSSH2_CHANNEL* channel;
} SSH2_CHANNEL;

/* Net::SSH2::SFTP object */
typedef struct SSH2_SFTP {
    SSH2* ss;
    SV* sv_ss;
    LIBSSH2_SFTP* sftp;
} SSH2_SFTP;

/* Net::SSH2::Listener object */
typedef struct SSH2_LISTENER {
    SSH2* ss;
    SV* sv_ss;
    LIBSSH2_LISTENER* listener;
} SSH2_LISTENER;

/* Net::SSH2::File object */
typedef struct SSH2_FILE {
    SSH2_SFTP* sf;
    SV* sv_sf;
    LIBSSH2_SFTP_HANDLE* handle;
} SSH2_FILE;

/* Net::SSH2::Dir object */
typedef struct SSH2_DIR {
    SSH2_SFTP* sf;
    SV* sv_sf;
    LIBSSH2_SFTP_HANDLE* handle;
} SSH2_DIR;

/* Net::SSH2::PublicKey object */
typedef struct SSH2_PUBLICKEY {
    SSH2* ss;
    SV* sv_ss;
    LIBSSH2_PUBLICKEY* pkey;
} SSH2_PUBLICKEY;

#if LIBSSH2_VERSION_NUM >= 0x010200

/* Net::SSH2::KnownHosts object */
typedef struct SSH2_KNOWNHOSTS {
    SSH2 *ss;
    SV *sv_ss;
    LIBSSH2_KNOWNHOSTS* knownhosts;
} SSH2_KNOWNHOSTS;

#endif

static int net_ss_debug_out = 0;
static unsigned long net_ch_gensym = 0;
static unsigned long net_fi_gensym = 0;

/* debug output */
static void debug(const char* format, ...) {
    if (net_ss_debug_out) {
        va_list va;
        va_start(va, format);
        vwarn(format, &va);
        va_end(va);
    }
}

/* libssh2 allocator thunks */
LIBSSH2_ALLOC_FUNC(local_alloc) {
    void *buf;
    New(0, buf, count, char);
    return buf;
}
LIBSSH2_REALLOC_FUNC(local_realloc) {
    return Renew(ptr, count, char);
}
LIBSSH2_FREE_FUNC(local_free) {
    Safefree(ptr);
}

/* set Net:SSH2-specific error message */
static void set_error(SSH2* ss, int errcode, const char* errmsg) {
    ss->errcode = errcode;
    if (ss->errmsg)
        SvREFCNT_dec(ss->errmsg);
    ss->errmsg = errmsg ? newSVpv(errmsg, 0) : NULL;
}    

/* clear our local error flag */
static void clear_error(SSH2* ss) {
    set_error(ss, LIBSSH2_ERROR_NONE, NULL/*errmsg*/);
}

/* split a string at commas and push each substring onto the perl stack */
static int split_comma(SV** sp, const char* str) {
    int i;
    const char* p;

    if (!str || !*str)
        return 0;

    i = 1;
    while ((p = strchr(str, ','))) {
        mXPUSHp(str, p - str);
        str = p + 1;
        ++i;
    }
    mXPUSHp(str, strlen(str));
    return i;
}

/* push a hash of values onto the return stack, for '%hash = func()' */
static int push_hv(SV** sp, HV* hv) {
    I32 keys = hv_iterinit(hv);
    const char* pv_key;
    I32 len_key;
    SV* value;

    EXTEND(SP, keys * 2);
    while ((value = hv_iternextsv(hv, (char**)&pv_key, &len_key))) {
        PUSHs(sv_2mortal(newSVpvn(pv_key, len_key)));
        PUSHs(sv_2mortal(SvREFCNT_inc(value)));
    }
    SvREFCNT_dec(hv);
    return keys * 2;
}

/* return NULL if undef or NULL, else return string */
static const char* default_string(SV* sv) {
    return (sv && SvPOK(sv)) ? SvPV_nolen(sv) : NULL;
}

/* return an integer constant from an SV name or value */
static int iv_constant_sv(const char *prefix, SV* c_sv, IV* piv) {
    int ret = 1;

    /* accept type as constant, constant without prefix, or numeric value */
    if (SvIOK(c_sv)) {
        *piv = SvIV(c_sv);
    } else {
        SV *sv = newSVsv(c_sv);
        char* str = SvPV_nolen(sv), * p;
        const char* pv;
        STRLEN len = strlen(prefix);

        for (p = str; *p; ++p)
            *p = toUPPER(*p);
        if (strncmp(str, prefix, len))
            sv_insert(sv, 0/*offset*/, 0/*replace*/, (char*)prefix, len);
        pv = SvPV(sv, len);
	    if (constant(aTHX_ pv, len, piv) != PERL_constant_ISIV)
            ret = 0;
        SvREFCNT_dec(sv);
    }
    return ret;
}

/* create a hash from an SFTP attributes structure */
static HV* hv_from_attrs(LIBSSH2_SFTP_ATTRIBUTES* attrs) {
    HV* hv = newHV();
    debug("hv_from_attrs: attrs->flags = %d\n", attrs->flags);
    if (attrs->flags & LIBSSH2_SFTP_ATTR_SIZE)
        hv_store(hv, "size", 4, newSVuv(attrs->filesize), 0/*hash*/);
    if (attrs->flags & LIBSSH2_SFTP_ATTR_UIDGID) {
        hv_store(hv, "uid", 3, newSVuv(attrs->uid), 0/*hash*/);
        hv_store(hv, "gid", 3, newSVuv(attrs->gid), 0/*hash*/);
    }
    if (attrs->flags & LIBSSH2_SFTP_ATTR_PERMISSIONS)
        hv_store(hv, "mode", 4, newSVuv(attrs->permissions), 0/*hash*/);
    if (attrs->flags & LIBSSH2_SFTP_ATTR_ACMODTIME) {
        hv_store(hv, "atime", 5, newSVuv(attrs->atime), 0/*hash*/);
        hv_store(hv, "mtime", 5, newSVuv(attrs->mtime), 0/*hash*/);
    }
    return hv;
}

/* return attributes from function, as flat hash or hashref */
#define XSRETURN_STAT_ATTRS(name) XSRETURN(return_stat_attrs(sp, &attrs, name))
    
static int return_stat_attrs(SV** sp, LIBSSH2_SFTP_ATTRIBUTES* attrs,
 SV* name) {
    HV* hv_attrs = hv_from_attrs(attrs);
    if (name)
        hv_store(hv_attrs, "name", 4, name, 0/*hash*/);

    switch (GIMME_V) {
    case G_SCALAR:
        PUSHs(sv_2mortal(newRV_noinc((SV*)hv_attrs)));
        return 1;
    case G_ARRAY:
        return push_hv(sp, hv_attrs);
    default:
        SvREFCNT_dec(hv_attrs);
    }
    return 0;
}

/* general wrapper */
#define NEW_ITEM(type, field, create, parent) do { \
    Newz(0/*id*/, RETVAL, 1, type); \
    if (RETVAL) { \
        RETVAL->parent = parent; \
        RETVAL->sv_##parent = SvREFCNT_inc(SvRV(ST(0))); \
        RETVAL->field = create; \
        debug(#create " -> 0x%p\n", RETVAL->field); \
    } \
    if (!RETVAL || !RETVAL->field) { \
        if (RETVAL) \
            SvREFCNT_dec(RETVAL->sv_##parent); \
        Safefree(RETVAL); \
        XSRETURN_EMPTY; \
    } \
} while(0)

/* wrap a libSSH2 channel */
#define NEW_CHANNEL(create) NEW_ITEM(SSH2_CHANNEL, channel, create, ss)

/* wrap a libSSH2 listener */
#define NEW_LISTENER(create) NEW_ITEM(SSH2_LISTENER, listener, create, ss)

/* wrap a libSSH2 SFTP connection */
#define NEW_SFTP(create) NEW_ITEM(SSH2_SFTP, sftp, create, ss)

/* wrap a libSSH2 SFTP file */
#define NEW_FILE(create) NEW_ITEM(SSH2_FILE, handle, create, sf)

/* wrap a libSSH2 SFTP directory */
#define NEW_DIR(create) NEW_ITEM(SSH2_DIR, handle, create, sf)

/* wrap a libSSH2 public key object */
#define NEW_PUBLICKEY(create) NEW_ITEM(SSH2_PUBLICKEY, pkey, create, ss)

/* wrap a libSSH2 knownhosts object */
#define NEW_KNOWNHOSTS(create) NEW_ITEM(SSH2_KNOWNHOSTS, knownhosts, create, ss)

static void
set_cb_args(pTHX_ AV* data) {
    GV *gv = gv_fetchpv("Net::SSH2::_cb_args", 1, SVt_PV);
    SV *sv = save_scalar(gv);
    sv_setsv(sv, sv_2mortal(newRV_inc((SV*)data)));
}

static SV*
get_cb_arg(pTHX_ I32 ix) {
    SV *sv = get_sv("Net::SSH2::_cb_args", 1);
    if (SvROK(sv)) {
        AV *data = (AV*)SvRV(sv);
        if (SvTYPE(data) == SVt_PVAV) {
            SV **svp = av_fetch(data, ix, 0);
            if (svp && *svp)
                return *svp;
            Perl_croak(aTHX_ "internal error: unable to fetch callback data slot %d", ix);
        }
    }
    Perl_croak(aTHX_ "internal error: unexpected structure found for callback data");
}

/* callback for returning a password via "keyboard-interactive" auth */
static LIBSSH2_USERAUTH_KBDINT_RESPONSE_FUNC(cb_kbdint_response_password) {
    if (num_prompts != 1 || prompts[0].echo) {
        int i;
        for (i = 0; i < num_prompts; ++i) {
            responses[i].text = NULL;
            responses[i].length = 0;
        }
    }
    else {
        /* single prompt, no echo: assume it's a password request */
        dTHX;
        SV *password = get_cb_arg(aTHX_ 0);
        STRLEN len_password;
        const char* pv_password = SvPV(password, len_password);

        responses[0].text = savepvn(pv_password, len_password);
        responses[0].length = len_password;
    }
}

/* thunk to call perl input-reading function for "keyboard-interactive" auth */
static LIBSSH2_USERAUTH_KBDINT_RESPONSE_FUNC(cb_kbdint_response_callback) {
    dTHX; dSP;
    int count, i;
    SV *cb = get_cb_arg(aTHX_ 0);
    SV *self = get_cb_arg(aTHX_ 1);
    SV *username = get_cb_arg(aTHX_ 2);

    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    EXTEND(SP, 4 + num_prompts);
    PUSHs(self);
    PUSHs(username);
    PUSHs(sv_2mortal(newSVpvn(name, name_len)));
    PUSHs(sv_2mortal(newSVpvn(instruction, instruction_len)));
    for (i = 0; i < num_prompts; ++i) {
        HV* hv = newHV();
        PUSHs(sv_2mortal(newRV_noinc((SV*)hv)));
        hv_store(hv, "text", 4, newSVpvn(prompts[i].text, prompts[i].length), 0);
        hv_store(hv, "echo", 4, newSVuv(prompts[i].echo), 0);
        responses[i].text = NULL;
        responses[i].length = 0;
    }
    PUTBACK;
    count = call_sv(cb, G_ARRAY);
    SPAGAIN;
    if (count > num_prompts) {
        Perl_warn(aTHX_ "Too many responses from callback, %d expected but %d found!",
                  num_prompts, count);
        while (count-- > num_prompts)
            POPs;
    }
    while (count-- > 0) {
        STRLEN len_response;
        SV *sv = POPs;
        char *pv_response = SvPV(sv, len_response);
        responses[count].text = savepvn(pv_response, len_response);
        responses[count].length = len_response;
    }
    PUTBACK;
    FREETMPS;
    LEAVE;
}

/* thunk to call perl password change function for "password" auth */
static LIBSSH2_PASSWD_CHANGEREQ_FUNC(cb_password_change_callback) {
    dTHX; dSP;
    int count;
    SV *cb = get_cb_arg(aTHX_ 0);
    SV *self = get_cb_arg(aTHX_ 1);
    SV *username = get_cb_arg(aTHX_ 2);

    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    XPUSHs(self);
    XPUSHs(username);
    PUTBACK;
    count = call_sv(cb, G_SCALAR);
    SPAGAIN;
    if (count > 0) {
        STRLEN len_password;
        const char* pv_password = SvPV(POPs, len_password);
        *newpw = savepvn(pv_password, len_password);
        *newpw_len = len_password;
    }
    else {
        *newpw = NULL;
        *newpw_len = 0;
    }
    PUTBACK;
    FREETMPS;
    LEAVE;
}

/* thunk to call perl SSH_MSG_IGNORE packet function */
static LIBSSH2_IGNORE_FUNC(cb_ignore_callback) {
    SSH2* ss = (SSH2*)*abstract;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    mXPUSHp(message, message_len);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_IGNORE], G_VOID);
    SPAGAIN; SP -= count; ax = (SP - PL_stack_base) + 1;

    PUTBACK; FREETMPS; LEAVE;
}

/* thunk to call perl SSH_MSG_DEBUG packet function */
static LIBSSH2_DEBUG_FUNC(cb_debug_callback) {
    SSH2* ss = (SSH2*)*abstract;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    mXPUSHi(always_display);
    mXPUSHp(message, message_len);
    mXPUSHp(language, language_len);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_DEBUG], G_VOID);
    SPAGAIN; SP -= count; ax = (SP - PL_stack_base) + 1;

    PUTBACK; FREETMPS; LEAVE;
}

/* thunk to call perl SSH_MSG_DISCONNECT packet function */
static LIBSSH2_DISCONNECT_FUNC(cb_disconnect_callback) {
    SSH2* ss = (SSH2*)*abstract;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    mXPUSHi(reason);
    mXPUSHp(message, message_len);
    mXPUSHp(language, language_len);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_DISCONNECT], G_VOID);
    SPAGAIN; SP -= count; ax = (SP - PL_stack_base) + 1;

    PUTBACK; FREETMPS; LEAVE;
}

/* thunk to call perl SSH_MSG_MACERROR packet function */
static LIBSSH2_MACERROR_FUNC(cb_macerror_callback) {
    SSH2* ss = (SSH2*)*abstract;
    int ret = 0;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    mXPUSHp(packet, packet_len);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_MACERROR], G_SCALAR);
    SPAGAIN; SP -= count ; ax = (SP - PL_stack_base) + 1;

    if (count > 0)
        ret = SvIV(ST(0));
 
    PUTBACK; FREETMPS; LEAVE;
    return ret;
}

/* thunk to call perl X11 forwarder packet function */
static LIBSSH2_X11_OPEN_FUNC(cb_x11_open_callback) {
    SSH2* ss = (SSH2*)*abstract;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    /*TODO: we actually need to push a channel here, but we don't know the
     *      SV of the channel (use a local hash?) */
    XPUSHs(&PL_sv_undef);
    mXPUSHp(shost, strlen(shost));
    mXPUSHi(sport);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_X11], G_VOID);
    SPAGAIN; SP -= count ; ax = (SP - PL_stack_base) + 1 ;

    PUTBACK; FREETMPS; LEAVE;
}

void * cb_as_void_ptr(void (*cb)()) {
    void * addr;
    memcpy(&addr, &cb, sizeof addr);
    return addr;
}

static void (*msg_cb[])() = {
    (void (*)())cb_ignore_callback,
    (void (*)())cb_debug_callback,
    (void (*)())cb_disconnect_callback,
    (void (*)())cb_macerror_callback,
    (void (*)())cb_x11_open_callback
};

#define MY_CXT_KEY "Net::SSH2::_guts" XS_VERSION

#ifdef HAVE_GCRYPT
#ifndef WIN32
GCRY_THREAD_OPTION_PTHREAD_IMPL;
#else
GCRY_THREAD_OPTION_PTH_IMPL;
#endif
#endif

typedef struct {
    HV* global_cb_data;
    UV tid;
} my_cxt_t;

START_MY_CXT

static UV get_my_thread_id(void) /* returns threads->tid() value */
{
    dSP;
    UV tid = 0;
    int count = 0;

#ifdef USE_ITHREADS
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSVpv("threads", 0)));
    PUTBACK;
    count = call_method("tid", G_SCALAR|G_EVAL);
    SPAGAIN;
    if (SvTRUE(ERRSV) || count != 1)
       /* if threads not loaded or an error occurs return 0 */
       tid = 0;
    else
       tid = (UV)POPi;
    PUTBACK;
    FREETMPS;
    LEAVE;
#endif

    return tid;
}

#if defined(USE_ITHREADS) && !defined(HAVE_GCRYPT)
/* IMPORTANT NOTE:
 * openssl locking was implemented according to http://www.openssl.org/docs/crypto/threads.html
 * we implement both static and dynamic locking as described on URL above
 * locking is supported when OPENSSL_THREADS macro is defined which means openssl-0.9.7 or newer
 * we intentionally do not implement cleanup of openssl's threading as it causes troubles
 * with apache-mpm-worker+mod_perl+mod_ssl+net-ssleay
 */

static perl_mutex *GLOBAL_openssl_mutex = NULL;

static void openssl_locking_function(int mode, int type, const char *file, int line)
{
    if (!GLOBAL_openssl_mutex) return;
    if (mode & CRYPTO_LOCK)
      MUTEX_LOCK(&GLOBAL_openssl_mutex[type]);
    else
      MUTEX_UNLOCK(&GLOBAL_openssl_mutex[type]);
}

#if OPENSSL_VERSION_NUMBER < 0x10000000L
static unsigned long openssl_threadid_func(void)
{
    dMY_CXT;
    return (unsigned long)(MY_CXT.tid);
}
#else
static void openssl_threadid_func(CRYPTO_THREADID *id)
{
    dMY_CXT;
    CRYPTO_THREADID_set_numeric(id, (unsigned long)(MY_CXT.tid));
}
#endif

struct CRYPTO_dynlock_value
{
    perl_mutex mutex;
};

static struct CRYPTO_dynlock_value *openssl_dynlocking_create_function(const char *file, int line)
{
    struct CRYPTO_dynlock_value *retval;
    New(0, retval, 1, struct CRYPTO_dynlock_value);
    if (!retval) return NULL;
    MUTEX_INIT(&retval->mutex);
    return retval;
}

static void openssl_dynlocking_lock_function(int mode, struct CRYPTO_dynlock_value *l, const char *file, int line)
{
    if (!l) return;
    if (mode & CRYPTO_LOCK)
      MUTEX_LOCK(&l->mutex);
    else
      MUTEX_UNLOCK(&l->mutex);
}

static void openssl_dynlocking_destroy_function(struct CRYPTO_dynlock_value *l, const char *file, int line)
{
    if (!l) return;
    MUTEX_DESTROY(&l->mutex);
    Safefree(l);
}

static void openssl_threads_init(void)
{
    int i;

    /* initialize static locking */
    if ( !CRYPTO_get_locking_callback() ) {
#if OPENSSL_VERSION_NUMBER < 0x10000000L
        if ( !CRYPTO_get_id_callback() ) {
#else
        if ( !CRYPTO_THREADID_get_callback() ) {
#endif
            New(0, GLOBAL_openssl_mutex, CRYPTO_num_locks(), perl_mutex);
            if (!GLOBAL_openssl_mutex) return;
            for (i=0; i<CRYPTO_num_locks(); i++) MUTEX_INIT(&GLOBAL_openssl_mutex[i]);
            CRYPTO_set_locking_callback(openssl_locking_function);

#ifndef WIN32
            /* no need for threadid_func() on Win32 */
#if OPENSSL_VERSION_NUMBER < 0x10000000L
            CRYPTO_set_id_callback(openssl_threadid_func);
#else
            CRYPTO_THREADID_set_callback(openssl_threadid_func);
#endif
#endif
        }
    }

    /* initialize dynamic locking */
    if ( !CRYPTO_get_dynlock_create_callback() &&
         !CRYPTO_get_dynlock_lock_callback() &&
         !CRYPTO_get_dynlock_destroy_callback() ) {
        CRYPTO_set_dynlock_create_callback(openssl_dynlocking_create_function);
        CRYPTO_set_dynlock_lock_callback(openssl_dynlocking_lock_function);
        CRYPTO_set_dynlock_destroy_callback(openssl_dynlocking_destroy_function);
    }
}

#else

/* no threads */
static void openssl_threads_init(void)
{
}

#endif

static void
croak_last_error(SSH2 *ss, const char *klass, const char *method) {
    char *errmsg;
    if ((ss->errcode != LIBSSH2_ERROR_NONE) && (ss->errmsg != NULL))
        errmsg = SvPV_nolen(ss->errmsg);
    else {
        if (libssh2_session_last_error(ss->session, &errmsg, NULL, 0) == LIBSSH2_ERROR_NONE)
            croak("Internal error: croak_last_error called but there was no error!");
    }
    croak("%s::%s: %s", klass, method, errmsg);
}

#define CROAK_LAST_ERROR(session, method) (croak_last_error((session), class, (method)))

/* perl module exports */

#line 782 "SSH2.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 924 "SSH2.c"

/* INCLUDE:  Including 'const-xs.inc' from 'SSH2.xs' */


XS_EUPXS(XS_Net__SSH2_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv;
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 949 "SSH2.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid Net::SSH2 macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined Net::SSH2 macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing Net::SSH2 macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 1027 "SSH2.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'SSH2.xs' from 'const-xs.inc' */

#define class "Net::SSH2"

XS_EUPXS(XS_Net__SSH2_CLONE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_CLONE)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 808 "SSH2.xs"
    MY_CXT_CLONE;
    MY_CXT.global_cb_data = newHV();
    MY_CXT.tid = get_my_thread_id();
    debug("%s::CLONE: tid=%d my_perl=0x%p\n", class, MY_CXT.tid, my_perl);
#line 1049 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "proto");
    {
	SSH2 *	RETVAL;
	SV*	proto = ST(0)
;
#line 816 "SSH2.xs"
    Newz(0/*id*/, RETVAL, 1, SSH2);
    if (RETVAL) {
        RETVAL->session = libssh2_session_init_ex(
         local_alloc, local_free, local_realloc, RETVAL);
    }
    if (!RETVAL || !RETVAL->session) {
        Safefree(RETVAL);
        XSRETURN_EMPTY;
    }
    clear_error(RETVAL);

    debug("Net::SSH2: created new object 0x%x\n", RETVAL);
#line 1078 "SSH2.c"
	ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), "Net::SSH2", (void *)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_trace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_trace)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ss, bitmask");
    {
	SSH2*	ss;
	SV*	bitmask = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_trace() - invalid session object")
;
#line 834 "SSH2.xs"
    libssh2_trace(ss->session, SvIV(bitmask));
#line 1104 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#if LIBSSH2_VERSION_MAJOR >= 1
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Net__SSH2_block_directions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_block_directions)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SV *	RETVAL;
	SSH2*	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_block_directions() - invalid session object")
;
#line 841 "SSH2.xs"
    RETVAL = newSViv((IV)libssh2_session_block_directions(ss->session));
#line 1130 "SSH2.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_Net__SSH2_block_directions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_block_directions)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2*	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_block_directions() - invalid session object")
;
#line 850 "SSH2.xs"
    croak("libssh2 version 1.0 or higher required for block_directions support");
#line 1157 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif
#if LIBSSH2_VERSION_NUM >= 0x010209
#define XSubPPtmpAAAC 1


XS_EUPXS(XS_Net__SSH2_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ss, timeout");
    {
	SSH2*	ss;
	long	timeout = (long)SvIV(ST(1))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_timeout() - invalid session object")
;
#line 859 "SSH2.xs"
    libssh2_session_set_timeout(ss->session, timeout);
#line 1185 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#else
#define XSubPPtmpAAAD 1


XS_EUPXS(XS_Net__SSH2_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ss, timeout");
    {
	SSH2*	ss;
	long	timeout = (long)SvIV(ST(1))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_timeout() - invalid session object")
;
#line 866 "SSH2.xs"
    croak("libssh2 version 1.2.9 or higher required for set_timeout support");
#line 1212 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2_blocking); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_blocking)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ss, blocking");
    {
	SSH2*	ss;
	SV*	blocking = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_blocking() - invalid session object")
;
#line 873 "SSH2.xs"
    clear_error(ss);
    libssh2_session_set_blocking(ss->session, SvTRUE(blocking));
    XSRETURN_IV(1);
#line 1239 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2*	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_DESTROY() - invalid session object")
;
#line 880 "SSH2.xs"
    debug("%s::DESTROY object 0x%x\n", class, ss);
    clear_error(ss);
    libssh2_session_free(ss->session);
    SvREFCNT_dec(ss->socket);
    Safefree(ss);
#line 1265 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_debug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_debug)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "SV*, debug");
    {
	SV*	debug = ST(1)
;
#line 889 "SSH2.xs"
    net_ss_debug_out = SvIV(debug) & 1;  /* allow for future flags */
#line 1282 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_version)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "name= NULL");
    {
	SV*	name;

	if (items < 1)
	    name = NULL;
	else {
	    name = ST(0)
;
	}
#line 894 "SSH2.xs"
    switch (GIMME_V) {
    case G_SCALAR:
        XSRETURN_PV(LIBSSH2_VERSION);
    case G_ARRAY:
        EXTEND(SP, 3);
        ST(0) = sv_2mortal(newSVpv(LIBSSH2_VERSION, 0));
#ifdef LIBSSH2_VERSION_NUM
        ST(1) = sv_2mortal(newSVuv(LIBSSH2_VERSION_NUM));
#else
        ST(1) = &PL_sv_undef;
#endif
        ST(2) = sv_2mortal(newSVpv(LIBSSH2_SSH_DEFAULT_BANNER, 0));
        XSRETURN(3);
    }
#line 1318 "SSH2.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_banner); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_banner)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ss, banner");
    {
#line 912 "SSH2.xs"
    int success;
    SV* sv_banner;
#line 1334 "SSH2.c"
	SSH2*	ss;
	SV*	banner = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_banner() - invalid session object")
;
#line 915 "SSH2.xs"
    clear_error(ss);
    sv_banner = newSVsv(banner);
    sv_insert(sv_banner, 0/*offset*/, 0/*len*/, "SSH-2.0-", 8);
    success = !libssh2_banner_set(ss->session, SvPV_nolen(sv_banner));
    SvREFCNT_dec(sv_banner);
    XSRETURN_IV(success);
#line 1351 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_error)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "ss, ...");
    {
#line 925 "SSH2.xs"
    SV* errmsg;
    int errcode;
#line 1367 "SSH2.c"
	SSH2*	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_error() - invalid session object")
;
#line 928 "SSH2.xs"
    if (items == 3) {
        set_error(ss, SvIV(ST(1)), SvPV_nolen(ST(2)));
        XSRETURN_EMPTY;
    } else if(items != 1)
        croak("%s::error: too many arguments", class);

    /* if we have a local error, take it, else use libSSH2's value */
    if (ss->errcode != LIBSSH2_ERROR_NONE && ss->errmsg != NULL) {
        errcode = ss->errcode;
        errmsg = SvREFCNT_inc(ss->errmsg);
    } else {
        char* errstr;
        int errlen;
        errcode = libssh2_session_last_error(
         ss->session, &errstr, &errlen, 0/*want_buf*/);
        errmsg = errstr ? newSVpvn(errstr, errlen) : NULL;
    }

    if (errcode == LIBSSH2_ERROR_NONE && errmsg == NULL)
        XSRETURN_EMPTY;
    switch (GIMME_V) {
    case G_SCALAR:
        XSRETURN_IV(errcode);
    case G_ARRAY: {
        SV* code;
        EXTEND(SP, 3);
        ST(0) = sv_2mortal(newSViv(errcode));
        if (errcode < 0) {
            code = (-errcode < countof(xs_libssh2_error)) ? 
             newSVpvf("LIBSSH2_ERROR_%s", xs_libssh2_error[-errcode]) :
             newSVpvf("LIBSSH2_ERROR_UNKNOWN(%d)", errcode);
        } else if(errcode > 0)
            code = newSVpv(Strerror(errcode), 0);
        else
            code = newSVpvn("", 0);  /* possibly set via set_error */
        ST(1) = sv_2mortal(code);
        ST(2) = sv_2mortal(errmsg);
        XSRETURN(3);
    }
    }
#line 1416 "SSH2.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_method); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_method)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "ss, method_type, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 972 "SSH2.xs"
    IV type;
    int i;
    SV* prefs;
    STRLEN len;
#line 1436 "SSH2.c"
	SSH2*	ss;
	SV*	method_type = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_method() - invalid session object")
;
#line 977 "SSH2.xs"
    clear_error(ss);
    if (!iv_constant_sv("LIBSSH2_METHOD_", method_type, &type))
        croak("%s::method: unknown method type: %s",
         class, SvPV_nolen(method_type));

    /* if there are no other parameters, return the current value */
    if (items <= 2) {
        const char *method = libssh2_session_methods(ss->session, (int)type);
        if (!method)
            XSRETURN_EMPTY;
        XSRETURN_PV(method);
    }

    /* accept prefs as a string or multiple strings, joining with "," */
    prefs = newSVpvn("", 0);
    for (i = 2; i < items; ++i) {
        const char* pv_pref;
        if (i > 2)
            sv_catpvn(prefs, ",", 1);
        pv_pref = SvPV(ST(i), len);
        sv_catpvn(prefs, pv_pref, len);
    }

    /* call and clean up */
    i = libssh2_session_method_pref(ss->session,
     (int)type, SvPV_nolen(prefs));
    SvREFCNT_dec(prefs);
    XSRETURN_IV(!i);
#line 1475 "SSH2.c"
	PUTBACK;
	return;
    }
}

#if LIBSSH2_VERSION_NUM >= 0x010200
#define XSubPPtmpAAAE 1


XS_EUPXS(XS_Net__SSH2_flag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_flag)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ss, flag, value");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1011 "SSH2.xs"
    IV flag_iv;
    int success;
#line 1497 "SSH2.c"
	SSH2*	ss;
	SV*	flag = ST(1)
;
	int	value = (int)SvIV(ST(2))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_flag() - invalid session object")
;
#line 1014 "SSH2.xs"
    clear_error(ss);
    if (!iv_constant_sv("LIBSSH2_FLAG_", flag, &flag_iv))
        croak("%s::method: unknown flag: %s", class, SvPV_nolen(flag));
    success = libssh2_session_flag(ss->session, (int)flag_iv, value);
    XSRETURN_IV(!success);
#line 1515 "SSH2.c"
	PUTBACK;
	return;
    }
}

#else
#define XSubPPtmpAAAF 1


XS_EUPXS(XS_Net__SSH2_flag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_flag)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ss, flag, value");
    {
	SSH2*	ss;
	SV*	flag = ST(1)
;
	int	value = (int)SvIV(ST(2))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_flag() - invalid session object")
;
#line 1025 "SSH2.xs"
    croak("libssh2 version 1.2 or higher required for flag support");
#line 1545 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_callback)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ss, type, callback= NULL");
    {
#line 1032 "SSH2.xs"
    IV i_type;
#line 1561 "SSH2.c"
	SSH2*	ss;
	SV*	type = ST(1)
;
	SV*	callback;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_callback() - invalid session object")
;

	if (items < 3)
	    callback = NULL;
	else {
	    callback = ST(2)
;
	}
#line 1034 "SSH2.xs"
    clear_error(ss);
    if (callback && !SvOK(callback))
        callback = NULL;
    if (callback && !(SvROK(callback) && SvTYPE(SvRV(callback)) == SVt_PVCV))
        croak("%s::callback: callback must be CODE ref", class);
    if (!iv_constant_sv("LIBSSH2_CALLBACK_", type, &i_type))
        croak("%s::callback: invalid callback type: %s",
         class, SvPV_nolen(callback));
    if (i_type < 0 || i_type >= countof(msg_cb))
        croak("%s::callback: don't know how to handle: %s",
         class, SvPV_nolen(callback));

    ss->sv_ss = SvRV(ST(0));  /* don't keep a reference, just store it */
    SvREFCNT_dec(ss->rgsv_cb[i_type]);
    libssh2_session_callback_set(ss->session,
     i_type, callback ? cb_as_void_ptr(msg_cb[i_type]) : NULL);
    SvREFCNT_inc(callback);
    ss->rgsv_cb[i_type] = callback;
    XSRETURN_IV(1);
#line 1599 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__startup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__startup)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ss, socket, store");
    {
#line 1057 "SSH2.xs"
    int success;
#line 1614 "SSH2.c"
	SSH2*	ss;
	int	socket = (int)SvIV(ST(1))
;
	SV *	store = ST(2)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss__startup() - invalid session object")
;
#line 1059 "SSH2.xs"
    clear_error(ss);
    success = !libssh2_session_startup(ss->session, socket);
    if (success && store) {
        ss->socket = SvREFCNT_inc(SvRV(store));
    }
    XSRETURN_IV(success);
#line 1633 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_sock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_sock)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SV *	RETVAL;
	SSH2*	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_sock() - invalid session object")
;
#line 1069 "SSH2.xs"
    if (ss->socket) {
        RETVAL = newRV_inc((SV *)ss->socket);
    } else {
        RETVAL = &PL_sv_undef;
    }
#line 1660 "SSH2.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_disconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_disconnect)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 4)
       croak_xs_usage(cv,  "ss, description= \"\", reason= SSH_DISCONNECT_BY_APPLICATION, lang= \"\"");
    {
	SSH2*	ss;
	const char*	description;
	int	reason;
	const char *	lang;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_disconnect() - invalid session object")
;

	if (items < 2)
	    description = "";
	else {
    description = (const char *)SvPV_nolen(ST(1))
;
	}

	if (items < 3)
	    reason = SSH_DISCONNECT_BY_APPLICATION;
	else {
	    reason = (int)SvIV(ST(2))
;
	}

	if (items < 4)
	    lang = "";
	else {
    lang = (const char *)SvPV_nolen(ST(3))
;
	}
#line 1081 "SSH2.xs"
    clear_error(ss);
    XSRETURN_IV(!libssh2_session_disconnect_ex(
     ss->session, reason, description, lang));
#line 1710 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_hostkey_hash); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_hostkey_hash)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ss, hash_type");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1088 "SSH2.xs"
    IV type;
    const char* hash;
    static STRLEN rglen[] = { 16/*MD5*/, 20/*SHA1*/ };
#line 1729 "SSH2.c"
	SSH2*	ss;
	SV*	hash_type = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_hostkey_hash() - invalid session object")
;
#line 1092 "SSH2.xs"
    clear_error(ss);
    if (!iv_constant_sv("LIBSSH2_HOSTKEY_HASH_", hash_type, &type) ||
     type < 1 || type > countof(rglen)) {
        croak("%s::hostkey: unknown hostkey hash: %s",
         class, SvPV_nolen(hash_type));
    }
    if ((hash = (const char*)libssh2_hostkey_hash(ss->session, type))) {
        PUSHs(sv_2mortal(newSVpvn(hash, rglen[type-1])));
        XSRETURN(1);
    }
    XSRETURN_EMPTY;
#line 1751 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SSH2_remote_hostkey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_remote_hostkey)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1107 "SSH2.xs"
    const char *key_pv;
    size_t key_len;
    int type_int;
#line 1771 "SSH2.c"
	SSH2*	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_remote_hostkey() - invalid session object")
;
#line 1111 "SSH2.xs"
    if ((key_pv = libssh2_session_hostkey(ss->session, &key_len, &type_int))) {
        XPUSHs(sv_2mortal(newSVpvn(key_pv, key_len)));
        if (GIMME_V != G_ARRAY)
            XSRETURN(1);
        else {
            XPUSHs(sv_2mortal(newSViv(type_int)));
            XSRETURN(2);
        }
    }
    else
        XSRETURN_EMPTY;
#line 1791 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SSH2_auth_list); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_list)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "ss, username= NULL");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1126 "SSH2.xs"
    const char* pv_username = NULL;
    char* auth;
    STRLEN len_username = 0;
    int count = 1;
#line 1812 "SSH2.c"
	SSH2*	ss;
	SV*	username;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_auth_list() - invalid session object")
;

	if (items < 2)
	    username = NULL;
	else {
	    username = ST(1)
;
	}
#line 1131 "SSH2.xs"
    clear_error(ss);
    if (username && SvPOK(username))
        pv_username = SvPV(username, len_username);
    auth = libssh2_userauth_list(ss->session, pv_username, len_username);
    if (!auth)
        XSRETURN_EMPTY;
    if (GIMME_V == G_ARRAY)
        count = split_comma(sp, auth);
    else
        PUSHs(sv_2mortal(newSVpv(auth, 0)));
    /* Safefree(auth); this causes a double-free segfault */
    XSRETURN(count);
#line 1841 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SSH2_auth_ok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_ok)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2*	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_auth_ok() - invalid session object")
;
#line 1147 "SSH2.xs"
    clear_error(ss);
    XSRETURN_IV(libssh2_userauth_authenticated(ss->session));
#line 1865 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_auth_password); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_password)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "ss, username, password= &PL_sv_undef, callback= &PL_sv_undef");
    {
#line 1155 "SSH2.xs"
    STRLEN len_username, len_password;
    const char *pv_username, *pv_password;
    int i, ok;
#line 1882 "SSH2.c"
	SV *	RETVAL;
	SSH2*	ss;
	SV*	username = ST(1)
;
	SV*	password;
	SV*	callback;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_auth_password() - invalid session object")
;

	if (items < 3)
	    password = &PL_sv_undef;
	else {
	    password = ST(2)
;
	}

	if (items < 4)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(3)
;
	}
#line 1159 "SSH2.xs"
    clear_error(ss);
    pv_username = SvPV(username, len_username);

    /* if we don't have a password, try for an unauthenticated login */
    if (!SvPOK(password)) {
        /* That's how libssh2 tells you authentication 'none' is valid */
        ok = ((libssh2_userauth_list(ss->session, pv_username, len_username) == NULL) &&
              libssh2_userauth_authenticated(ss->session));
    }
    else {
        if (SvOK(callback)) {
            if (!(SvROK(callback) && SvTYPE(SvRV(callback)) == SVt_PVCV))
                Perl_croak(aTHX_ "%s::auth_password: callback must be CODE ref", class);
            else {
                AV *cb_args = (AV*)sv_2mortal((SV*)newAV());
                av_push(cb_args, newSVsv(callback));
                av_push(cb_args, newSVsv(ST(0))); /*session */
                av_push(cb_args, newSVsv(username));
                set_cb_args(aTHX_ cb_args);
            }
        }

        pv_password = SvPV(password, len_password);
        ok = (libssh2_userauth_password_ex(ss->session,
                                           pv_username, len_username,
                                           pv_password, len_password,
                                           (SvOK(callback) ? cb_password_change_callback : NULL)) >= 0);
    }
    RETVAL = (ok ? &PL_sv_yes : &PL_sv_no);
#line 1939 "SSH2.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#if LIBSSH2_VERSION_NUM >= 0x010203
#define XSubPPtmpAAAG 1


XS_EUPXS(XS_Net__SSH2_auth_agent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_agent)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ss, username");
    {
#line 1196 "SSH2.xs"
    LIBSSH2_AGENT *agent;
    int old_blocking;
#line 1960 "SSH2.c"
	SV *	RETVAL;
	SSH2*	ss;
	const char*    username = (const char *)SvPV_nolen(ST(1))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_auth_agent() - invalid session object")
;
#line 1199 "SSH2.xs"
    RETVAL = &PL_sv_no;
    clear_error(ss);
    /* unfortunatelly this can't be make to work on nb mode */
    old_blocking = libssh2_session_get_blocking(ss->session);
    libssh2_session_set_blocking(ss->session, 1);
    if ((agent = libssh2_agent_init(ss->session)) != NULL) {
        if (libssh2_agent_connect(agent) == LIBSSH2_ERROR_NONE) {
            if (libssh2_agent_list_identities(agent) == LIBSSH2_ERROR_NONE) {
                struct libssh2_agent_publickey *identity = NULL;
                while (libssh2_agent_get_identity(agent, &identity, identity) == 0) {
                    if (libssh2_agent_userauth(agent, username, identity) == LIBSSH2_ERROR_NONE) {
                        RETVAL = &PL_sv_yes;
                        break;
                    }
                }
            }
            libssh2_agent_disconnect(agent);
        }
        libssh2_agent_free(agent);
    }
    libssh2_session_set_blocking(ss->session, old_blocking);
#line 1993 "SSH2.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAH 1


XS_EUPXS(XS_Net__SSH2_auth_agent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_agent)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ss, username");
    {
	SSH2*	ss;
	SV*	username = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_auth_agent() - invalid session object")
;
#line 1228 "SSH2.xs"
    croak("libssh2 version 1.2.3 or higher required for agent support");
#line 2022 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2_auth_publickey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_publickey)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "ss, username, publickey, privatekey, passphrase= NULL");
    {
#line 1236 "SSH2.xs"
    const char* pv_username;
    STRLEN len_username;
#line 2039 "SSH2.c"
	SSH2*	ss;
	SV*	username = ST(1)
;
	SV*	publickey = ST(2)
;
	const char*    privatekey = (const char *)SvPV_nolen(ST(3))
;
	SV*	passphrase;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_auth_publickey() - invalid session object")
;

	if (items < 5)
	    passphrase = NULL;
	else {
	    passphrase = ST(4)
;
	}
#line 1239 "SSH2.xs"
    clear_error(ss);
    pv_username = SvPV(username, len_username);

    XSRETURN_IV(!libssh2_userauth_publickey_fromfile_ex(ss->session,
     pv_username, len_username, default_string(publickey), privatekey,
     default_string(passphrase)));
#line 2068 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_auth_hostbased); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_hostbased)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 7)
       croak_xs_usage(cv,  "ss, username, publickey, privatekey, hostname, local_username= NULL, passphrase= NULL");
    {
#line 1251 "SSH2.xs"
    const char* pv_username, * pv_hostname, * pv_local_username;
    STRLEN len_username, len_hostname, len_local_username;
#line 2084 "SSH2.c"
	SSH2*	ss;
	SV*	username = ST(1)
;
	const char*    publickey = (const char *)SvPV_nolen(ST(2))
;
	const char*    privatekey = (const char *)SvPV_nolen(ST(3))
;
	SV*	hostname = ST(4)
;
	SV*	local_username;
	SV*	passphrase;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_auth_hostbased() - invalid session object")
;

	if (items < 6)
	    local_username = NULL;
	else {
	    local_username = ST(5)
;
	}

	if (items < 7)
	    passphrase = NULL;
	else {
	    passphrase = ST(6)
;
	}
#line 1254 "SSH2.xs"
    clear_error(ss);
    pv_username = SvPV(username, len_username);
    pv_hostname = SvPV(hostname, len_hostname);

    if (!local_username || !SvPOK(local_username)) {
        pv_local_username = pv_username;
        len_local_username = len_username;
    } else
        pv_local_username = SvPV(local_username, len_local_username);

    XSRETURN_IV(!libssh2_userauth_hostbased_fromfile_ex(ss->session,
     pv_username, len_username, publickey, privatekey,
     default_string(passphrase),
     pv_hostname, len_hostname, pv_local_username, len_local_username));
#line 2131 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_auth_keyboard); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_keyboard)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ss, username, password= NULL");
    {
#line 1272 "SSH2.xs"
    const char* pv_username;
    STRLEN len_username;
    int rc;
    AV *cb_args;
#line 2149 "SSH2.c"
	SV *	RETVAL;
	SSH2*	ss;
	SV*	username = ST(1)
;
	SV*	password;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_auth_keyboard() - invalid session object")
;

	if (items < 3)
	    password = NULL;
	else {
	    password = ST(2)
;
	}
#line 1277 "SSH2.xs"
    clear_error(ss);
    pv_username = SvPV(username, len_username);

    /* we either have a password, or a reference to a callback */

    if (!password || !SvOK(password)) {
        password = sv_2mortal(newRV_inc((SV*)get_cv("Net::SSH2::_cb_kbdint_response_default", 1)));
        if (!SvOK(password))
            Perl_croak(aTHX_ "Internal error: unable to retrieve callback");
    }

    cb_args = (AV*)sv_2mortal((SV*)newAV());
    av_push(cb_args, newSVsv(password));
    av_push(cb_args, newSVsv(ST(0))); /*session */
    av_push(cb_args, newSVsv(username));
    set_cb_args(aTHX_ cb_args);

    if (SvROK(password) && (SvTYPE(SvRV(password)) == SVt_PVCV))
        rc = libssh2_userauth_keyboard_interactive_ex(ss->session,
                                                      pv_username, len_username,
                                                      cb_kbdint_response_callback);
    else
        rc = libssh2_userauth_keyboard_interactive_ex(ss->session,
                                                      pv_username, len_username,
                                                      cb_kbdint_response_password);
    RETVAL = (rc < 0 ? &PL_sv_no : &PL_sv_yes);
#line 2195 "SSH2.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#if LIBSSH2_VERSION_NUM >= 0x010205
#define XSubPPtmpAAAI 1


XS_EUPXS(XS_Net__SSH2_keepalive_config); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_keepalive_config)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ss, want_reply, interval");
    {
	SSH2 *	ss;
	int	want_reply = (int)SvIV(ST(1))
;
	unsigned int	interval = (unsigned int)SvUV(ST(2))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_keepalive_config() - invalid session object")
;
#line 1311 "SSH2.xs"
    libssh2_keepalive_config(ss->session, want_reply, interval);
#line 2226 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_keepalive_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_keepalive_send)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1316 "SSH2.xs"
    int success;
    int seconds_to_next;
#line 2244 "SSH2.c"
	SSH2 *	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_keepalive_send() - invalid session object")
;
#line 1319 "SSH2.xs"
    success = libssh2_keepalive_send(ss->session, &seconds_to_next);
    if (success == LIBSSH2_ERROR_NONE)
        XSRETURN_IV(seconds_to_next);
    else
        XSRETURN_EMPTY;
#line 2258 "SSH2.c"
	PUTBACK;
	return;
    }
}

#else
#define XSubPPtmpAAAJ 1


XS_EUPXS(XS_Net__SSH2_keepalive_config); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_keepalive_config)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ss, want_reply, interval");
    {
	SSH2 *	ss;
	int	want_reply = (int)SvIV(ST(1))
;
	unsigned int	interval = (unsigned int)SvUV(ST(2))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_keepalive_config() - invalid session object")
;
#line 1330 "SSH2.xs"
    croak("libssh2 version 1.2.5 or higher required for keepalive_config support");
#line 2288 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_keepalive_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_keepalive_send)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2 *	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_keepalive_send() - invalid session object")
;
#line 1335 "SSH2.xs"
    croak("libssh2 version 1.2.5 or higher required for keepalive_send support");
#line 2310 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2_channel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_channel)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 4)
       croak_xs_usage(cv,  "ss, channel_type= NULL, window_size= LIBSSH2_CHANNEL_WINDOW_DEFAULT, packet_size= LIBSSH2_CHANNEL_PACKET_DEFAULT");
    {
#line 1344 "SSH2.xs"
    const char* pv_channel_type;
    STRLEN len_channel_type;
#line 2327 "SSH2.c"
	SSH2_CHANNEL *	RETVAL;
	SSH2*	ss;
	SV*	channel_type;
	int	window_size;
	int	packet_size;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_channel() - invalid session object")
;

	if (items < 2)
	    channel_type = NULL;
	else {
	    channel_type = ST(1)
;
	}

	if (items < 3)
	    window_size = LIBSSH2_CHANNEL_WINDOW_DEFAULT;
	else {
	    window_size = (int)SvIV(ST(2))
;
	}

	if (items < 4)
	    packet_size = LIBSSH2_CHANNEL_PACKET_DEFAULT;
	else {
	    packet_size = (int)SvIV(ST(3))
;
	}
#line 1347 "SSH2.xs"
    clear_error(ss);
    if (channel_type)
        pv_channel_type = SvPV(channel_type, len_channel_type);
    else {
        pv_channel_type = "session";
        len_channel_type = 7;
    }

    NEW_CHANNEL(libssh2_channel_open_ex(ss->session,
     pv_channel_type, len_channel_type, window_size, packet_size,
     NULL/*message*/, 0/*message_len*/));
#line 2372 "SSH2.c"
	ST(0) = sv_newmortal();
    {
    GV* gv = (GV*)newSVrv(ST(0), "Net::SSH2::Channel");
    IO* io = (IO*)newSV(0);
    const char* name = form("_GEN_%ld", (long)net_ch_gensym++);
    SvUPGRADE((SV*)gv, SVt_PVGV);
    SvUPGRADE((SV*)io, SVt_PVIO);
    gv_init(gv, gv_stashpv("Net::SSH2::Channel", 0/*create*/),
     name, strlen(name), 0/*multi*/);
    GvSV(gv) = newSViv(PTR2IV(RETVAL));
    GvIOp(gv) = io;
    if (PERL_VERSION > 6) {
      sv_magic((SV*)io, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    } else {
      sv_magic((SV*)gv, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    }
    }
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__scp_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__scp_get)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ss, path, stat= NULL");
    {
#line 1364 "SSH2.xs"
    struct stat st;
#line 2404 "SSH2.c"
	SSH2_CHANNEL *	RETVAL;
	SSH2*	ss;
	const char*    path = (const char *)SvPV_nolen(ST(1))
;
	HV*	stat;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss__scp_get() - invalid session object")
;

	if (items < 3)
	    stat = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(2);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			stat = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak(aTHX_ "%s: %s is not a HASH reference",
				    "Net::SSH2::_scp_get",
				    "stat");
		    }
	    } STMT_END
;
	}
#line 1366 "SSH2.xs"
    clear_error(ss);
    NEW_CHANNEL(libssh2_scp_recv(ss->session, path, &st));
    if (stat) {
        hv_clear(stat);
        hv_store(stat, "mode",  4, newSVuv(st.st_mode),  0/*hash*/);
        hv_store(stat, "uid",   3, newSVuv(st.st_uid),   0/*hash*/);
        hv_store(stat, "gid",   3, newSVuv(st.st_gid),   0/*hash*/);
        hv_store(stat, "size",  4, newSVuv(st.st_size),  0/*hash*/);
        hv_store(stat, "atime", 5, newSVuv((time_t)st.st_atime), 0/*hash*/);
        hv_store(stat, "mtime", 5, newSViv((time_t)st.st_mtime), 0/*hash*/);
    }
#line 2446 "SSH2.c"
	ST(0) = sv_newmortal();
    {
    GV* gv = (GV*)newSVrv(ST(0), "Net::SSH2::Channel");
    IO* io = (IO*)newSV(0);
    const char* name = form("_GEN_%ld", (long)net_ch_gensym++);
    SvUPGRADE((SV*)gv, SVt_PVGV);
    SvUPGRADE((SV*)io, SVt_PVIO);
    gv_init(gv, gv_stashpv("Net::SSH2::Channel", 0/*create*/),
     name, strlen(name), 0/*multi*/);
    GvSV(gv) = newSViv(PTR2IV(RETVAL));
    GvIOp(gv) = io;
    if (PERL_VERSION > 6) {
      sv_magic((SV*)io, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    } else {
      sv_magic((SV*)gv, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    }
    }
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__scp_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__scp_put)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 6)
       croak_xs_usage(cv,  "ss, path, mode, size, mtime= 0, atime= 0");
    {
	SSH2_CHANNEL *	RETVAL;
	SSH2*	ss;
	const char*    path = (const char *)SvPV_nolen(ST(1))
;
	int	mode = (int)SvIV(ST(2))
;
	size_t	size = (size_t)SvUV(ST(3))
;
	long	mtime;
	long	atime;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss__scp_put() - invalid session object")
;

	if (items < 5)
	    mtime = 0;
	else {
	    mtime = (long)SvIV(ST(4))
;
	}

	if (items < 6)
	    atime = 0;
	else {
	    atime = (long)SvIV(ST(5))
;
	}
#line 1384 "SSH2.xs"
    clear_error(ss);
    NEW_CHANNEL(libssh2_scp_send_ex(ss->session,
     path, mode, size, mtime, atime));
#line 2510 "SSH2.c"
	ST(0) = sv_newmortal();
    {
    GV* gv = (GV*)newSVrv(ST(0), "Net::SSH2::Channel");
    IO* io = (IO*)newSV(0);
    const char* name = form("_GEN_%ld", (long)net_ch_gensym++);
    SvUPGRADE((SV*)gv, SVt_PVGV);
    SvUPGRADE((SV*)io, SVt_PVIO);
    gv_init(gv, gv_stashpv("Net::SSH2::Channel", 0/*create*/),
     name, strlen(name), 0/*multi*/);
    GvSV(gv) = newSViv(PTR2IV(RETVAL));
    GvIOp(gv) = io;
    if (PERL_VERSION > 6) {
      sv_magic((SV*)io, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    } else {
      sv_magic((SV*)gv, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    }
    }
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_tcpip); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_tcpip)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 5)
       croak_xs_usage(cv,  "ss, host, port, shost= NULL, sport= 0");
    {
	SSH2_CHANNEL *	RETVAL;
	SSH2*	ss;
	const char*    host = (const char *)SvPV_nolen(ST(1))
;
	int	port = (int)SvIV(ST(2))
;
	const char*	shost;
	int	sport;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_tcpip() - invalid session object")
;

	if (items < 4)
	    shost = NULL;
	else {
    shost = (const char *)SvPV_nolen(ST(3))
;
	}

	if (items < 5)
	    sport = 0;
	else {
	    sport = (int)SvIV(ST(4))
;
	}
#line 1394 "SSH2.xs"
    if (!shost)
        shost = "127.0.0.1";
    if (!sport)
        sport = 22;
    NEW_CHANNEL(libssh2_channel_direct_tcpip_ex(ss->session,
     (char*)host, port, (char*)shost, sport));
#line 2575 "SSH2.c"
	ST(0) = sv_newmortal();
    {
    GV* gv = (GV*)newSVrv(ST(0), "Net::SSH2::Channel");
    IO* io = (IO*)newSV(0);
    const char* name = form("_GEN_%ld", (long)net_ch_gensym++);
    SvUPGRADE((SV*)gv, SVt_PVGV);
    SvUPGRADE((SV*)io, SVt_PVIO);
    gv_init(gv, gv_stashpv("Net::SSH2::Channel", 0/*create*/),
     name, strlen(name), 0/*multi*/);
    GvSV(gv) = newSViv(PTR2IV(RETVAL));
    GvIOp(gv) = io;
    if (PERL_VERSION > 6) {
      sv_magic((SV*)io, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    } else {
      sv_magic((SV*)gv, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    }
    }
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_listen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_listen)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 5)
       croak_xs_usage(cv,  "ss, port, host= NULL, bound_port= NULL, queue_maxsize= 16");
    {
#line 1407 "SSH2.xs"
    int i_bound_port;
#line 2607 "SSH2.c"
	SSH2_LISTENER *	RETVAL;
	SSH2*	ss;
	int	port = (int)SvIV(ST(1))
;
	const char*	host;
	SV*	bound_port;
	int	queue_maxsize;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_listen() - invalid session object")
;

	if (items < 3)
	    host = NULL;
	else {
    host = (const char *)SvPV_nolen(ST(2))
;
	}

	if (items < 4)
	    bound_port = NULL;
	else {
	    bound_port = ST(3)
;
	}

	if (items < 5)
	    queue_maxsize = 16;
	else {
	    queue_maxsize = (int)SvIV(ST(4))
;
	}
#line 1409 "SSH2.xs"
    if (bound_port && SvOK(bound_port)) {
        if (!SvROK(bound_port) && SvTYPE(SvRV(bound_port)) <= SVt_PVNV)
            croak("%s::listen: bound port must be scalar reference", class);
    } else
        bound_port = NULL;
    NEW_LISTENER(libssh2_channel_forward_listen_ex(ss->session,
     (char*)host, port, bound_port ? &i_bound_port : NULL, queue_maxsize));
    if (RETVAL && bound_port)
        sv_setiv(SvRV(bound_port), i_bound_port);
#line 2652 "SSH2.c"
	ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), "Net::SSH2::Listener", (void *)RETVAL);
    }
    XSRETURN(1);
}

#if LIBSSH2_VERSION_NUM >= 0x010200
#define XSubPPtmpAAAK 1


XS_EUPXS(XS_Net__SSH2_known_hosts); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_known_hosts)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2_KNOWNHOSTS *	RETVAL;
	SSH2 *	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_known_hosts() - invalid session object")
;
#line 1426 "SSH2.xs"
    NEW_KNOWNHOSTS(libssh2_knownhost_init(ss->session));
#line 2680 "SSH2.c"
	ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), "Net::SSH2::KnownHosts", (void *)RETVAL);
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAL 1


XS_EUPXS(XS_Net__SSH2_known_hosts); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_known_hosts)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2 *	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_known_hosts() - invalid session object")
;
#line 1435 "SSH2.xs"
    croak("libssh2 version 1.2 or higher required for known_hosts support");
#line 2707 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2__poll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__poll)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ss, timeout, event");
    {
#line 1442 "SSH2.xs"
    LIBSSH2_POLLFD* pollfd;
    int i, count, changed;
#line 2724 "SSH2.c"
	SSH2*	ss;
	int	timeout = (int)SvIV(ST(1))
;
	AV*	event;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss__poll() - invalid session object")
;

    if(SvROK(ST(2)) && SvTYPE(SvRV(ST(2))) == SVt_PVAV)
        event = (AV*)SvRV(ST(2));
    else
        croak("event is not an array reference")
;
#line 1445 "SSH2.xs"
    clear_error(ss);
    count = av_len(event) + 1;
    debug("%s::poll: timeout = %d, array[%d]\n", class, timeout, count);
    if (!count)  /* some architectures return null for malloc(0) */
        XSRETURN_IV(0);

    New(0, pollfd, count, LIBSSH2_POLLFD);

    if (!pollfd) {
        set_error(ss, 0, "out of memory allocating pollfd structures");
        XSRETURN_EMPTY;
    }
    for (i = 0; i < count; ++i) {
        SV* sv = *av_fetch(event, i, 0/*lval*/), ** handle, ** events;
        HV* hv;

        if (!SvROK(sv) || SvTYPE(SvRV(sv)) != SVt_PVHV)
            croak("%s::poll: array element %d is not hash", class, i);
        hv = (HV*)SvRV(sv);

        if (!(handle = hv_fetch(hv, "handle", 6, 0/*lval*/)) || !*handle)
            croak("%s::poll: array element %d missing handle", class, i);
        if (sv_isobject(*handle)) {
            const char* package = HvNAME(SvSTASH(SvRV(*handle)));
            if (strEQ(package, "Net::SSH2::Channel")) {
                debug("- [%d] = channel\n", i);
                pollfd[i].type = LIBSSH2_POLLFD_CHANNEL;
                pollfd[i].fd.channel =
                 ((SSH2_CHANNEL*)SvIVX(GvSV((GV*)SvRV(*handle))))->channel;
            } else if(strEQ(package, "Net::SSH2::Listener")) {
                debug("- [%d] = listener\n", i);
                pollfd[i].type = LIBSSH2_POLLFD_LISTENER;
                pollfd[i].fd.listener =
                 ((SSH2_LISTENER*)SvIVX(SvRV(*handle)))->listener;
            } else {
                croak("%s::poll: invalid handle object in array (%d): %s",
                 class, i, package);
            }
        } else if(SvIOK(*handle)) {
            pollfd[i].type = LIBSSH2_POLLFD_SOCKET;
            pollfd[i].fd.socket = SvIV(*handle);
            debug("- [%d] = file(%d)\n", i, pollfd[i].fd.socket);
        } else {
            croak("%s::poll: invalid handle in array (%d): %s",
             class, i, SvPV_nolen(*handle));
        }

        events = hv_fetch(hv, "events", 6, 0/*lval*/);
        if (!events || !*events || !SvIOK(*events)) {
            croak("%s::poll: bad or missing event mask in array (%d)",
             class, i);
        }
        pollfd[i].events = SvIV(*events);
        pollfd[i].revents = 0;
        debug("- [%d] events %d\n", i, pollfd[i].events);
    }

    changed = libssh2_poll(pollfd, count, timeout);
    debug("- libssh2_poll returned %d\n", changed);

    if (changed < 0)
        count = 0;
    for (i = 0; i < count; ++i) {
        HV* hv = (HV*)SvRV(*av_fetch(event, i, 0/*lval*/));
        hv_store(hv, "revents", 7, newSViv(pollfd[i].revents), 0/*hash*/);
        debug("- [%d] revents %d\n", i, pollfd[i].revents);
    }

    Safefree(pollfd);
    if (changed < 0)
        XSRETURN_EMPTY;
    XSRETURN_IV(changed);
#line 2814 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_sftp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_sftp)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2_SFTP *	RETVAL;
	SSH2*	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_sftp() - invalid session object")
;
#line 1521 "SSH2.xs"
    clear_error(ss);
    NEW_SFTP(libssh2_sftp_init(ss->session));
#line 2838 "SSH2.c"
	ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), "Net::SSH2::SFTP", (void *)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_public_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_public_key)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2_PUBLICKEY *	RETVAL;
	SSH2*	ss;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ss = (SSH2 *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::net_ss_public_key() - invalid session object")
;
#line 1529 "SSH2.xs"
    clear_error(ss);
    NEW_PUBLICKEY(libssh2_publickey_init(ss->session));
#line 2864 "SSH2.c"
	ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), "Net::SSH2::PublicKey", (void *)RETVAL);
    }
    XSRETURN(1);
}

#undef class
#define class "Net::SSH2::Channel"

XS_EUPXS(XS_Net__SSH2__Channel_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_DESTROY() - invalid channel object")
;
#line 1545 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    clear_error(ch->ss);
    libssh2_channel_free(ch->channel);
    SvREFCNT_dec(ch->sv_ss);
    Safefree(ch);
#line 2894 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_session); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_session)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_session() - invalid channel object")
;
#line 1554 "SSH2.xs"
    ST(0) = sv_2mortal(newRV_inc(ch->sv_ss));
    XSRETURN(1);
#line 2917 "SSH2.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__Channel_setenv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_setenv)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "ch, ...");
    {
#line 1560 "SSH2.xs"
    int i, success = 0;
    const char* pv_key, * pv_value;
    STRLEN len_key, len_value;
#line 2934 "SSH2.c"
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_setenv() - invalid channel object")
;
#line 1564 "SSH2.xs"
    clear_error(ch->ss);
    for (i = 1; i < items; i += 2) {
        if (i + 1 == items)
            croak("%s::setenv: key without value", class);
        pv_key = SvPV(ST(i), len_key);
        pv_value = SvPV(ST(i + 1), len_value);
        success += !libssh2_channel_setenv_ex(ch->channel,
         (char*)pv_key, len_key, (char*)pv_value, len_value);
    }
    XSRETURN_IV(success);
#line 2953 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#if LIBSSH2_VERSION_NUM >= 0x010208
#define XSubPPtmpAAAM 1


XS_EUPXS(XS_Net__SSH2__Channel_exit_signal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_exit_signal)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
#line 1580 "SSH2.xs"
    char *exitsignal = NULL;  
#line 2971 "SSH2.c"
	SV *	RETVAL;
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_exit_signal() - invalid channel object")
;
#line 1582 "SSH2.xs"
    clear_error(ch->ss);
    RETVAL;
    libssh2_channel_get_exit_signal(ch->channel, &exitsignal,
        NULL, NULL, NULL, NULL, NULL);
    if (exitsignal) {
        RETVAL = newSVpv(exitsignal, 0);
        libssh2_free(ch->ss->session, exitsignal);
    }
    else
        RETVAL = &PL_sv_undef;
#line 2991 "SSH2.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAN 1


XS_EUPXS(XS_Net__SSH2__Channel_exit_signal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_exit_signal)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_exit_signal() - invalid channel object")
;
#line 1600 "SSH2.xs"
    croak("libssh2 version 1.2.8 or higher required for exit_signal support");
#line 3018 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2__Channel_blocking); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_blocking)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ch, blocking");
    {
	SSH2_CHANNEL*	ch;
	SV*	blocking = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_blocking() - invalid channel object")
;
#line 1607 "SSH2.xs"
    clear_error(ch->ss);
    libssh2_channel_set_blocking(ch->channel, SvTRUE(blocking));
    XSRETURN_IV(1);
#line 3045 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_eof); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_eof)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_eof() - invalid channel object")
;
#line 1614 "SSH2.xs"
   clear_error(ch->ss);
   XSRETURN_IV(libssh2_channel_eof(ch->channel));
#line 3068 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_send_eof); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_send_eof)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_send_eof() - invalid channel object")
;
#line 1620 "SSH2.xs"
    clear_error(ch->ss);
    XSRETURN_IV(!libssh2_channel_send_eof(ch->channel));
#line 3091 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_close() - invalid channel object")
;
#line 1626 "SSH2.xs"
    clear_error(ch->ss);
    XSRETURN_IV(!libssh2_channel_close(ch->channel));
#line 3114 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_wait_closed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_wait_closed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_wait_closed() - invalid channel object")
;
#line 1632 "SSH2.xs"
    clear_error(ch->ss);
    XSRETURN_IV(!libssh2_channel_wait_closed(ch->channel));
#line 3137 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_exit_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_exit_status)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_exit_status() - invalid channel object")
;
#line 1638 "SSH2.xs"
    clear_error(ch->ss);
    XSRETURN_IV(libssh2_channel_get_exit_status(ch->channel));
#line 3160 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#if LIBSSH2_VERSION_MAJOR >= 1
#define XSubPPtmpAAAO 1


XS_EUPXS(XS_Net__SSH2__Channel_pty); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_pty)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 5)
       croak_xs_usage(cv,  "ch, terminal, modes= NULL, width= 0, height= 0");
    {
#line 1647 "SSH2.xs"
    const char* pv_terminal, * pv_modes = NULL;
    STRLEN len_terminal, len_modes = 0;
    int width_px = LIBSSH2_TERM_WIDTH_PX, height_px = LIBSSH2_TERM_HEIGHT_PX;
#line 3180 "SSH2.c"
	SSH2_CHANNEL*	ch;
	SV*	terminal = ST(1)
;
	SV*	modes;
	int	width;
	int	height;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_pty() - invalid channel object")
;

	if (items < 3)
	    modes = NULL;
	else {
	    modes = ST(2)
;
	}

	if (items < 4)
	    width = 0;
	else {
	    width = (int)SvIV(ST(3))
;
	}

	if (items < 5)
	    height = 0;
	else {
	    height = (int)SvIV(ST(4))
;
	}
#line 1651 "SSH2.xs"
    pv_terminal = SvPV(terminal, len_terminal);
    if (modes && SvPOK(modes))
        pv_modes = SvPV(modes, len_modes);

    if (!width)
        width = LIBSSH2_TERM_WIDTH;
    else if(width < 0) {
        width_px = -width;
        width = 0;
    }

    if (!height)
        height = LIBSSH2_TERM_HEIGHT;
    else if(height < 0) {
        height_px = -height;
        height = 0;
    }

    XSRETURN_IV(!libssh2_channel_request_pty_ex(ch->channel,
     (char*)pv_terminal, len_terminal, (char*)pv_modes, len_modes,
     width, height, width_px, height_px));
#line 3236 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_pty_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_pty_size)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "ch, width= 0, height= 0");
    {
#line 1676 "SSH2.xs"
    int width_px = LIBSSH2_TERM_WIDTH_PX, height_px = LIBSSH2_TERM_HEIGHT_PX;
#line 3251 "SSH2.c"
	SSH2_CHANNEL*	ch;
	int	width;
	int	height;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_pty_size() - invalid channel object")
;

	if (items < 2)
	    width = 0;
	else {
	    width = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    height = 0;
	else {
	    height = (int)SvIV(ST(2))
;
	}
#line 1678 "SSH2.xs"
    if (!width)
        croak("%s::pty_size: required parameter width missing", class);
    else if(width < 0) {
        width_px = -width;
        width = 0;
    }

    if (!height)
        croak("%s::pty_size: required parameter height missing", class);
    else if(height < 0) {
        height_px = -height;
        height = 0;
    }

    XSRETURN_IV(!libssh2_channel_request_pty_size_ex(ch->channel,
     width, height, width_px, height_px));
#line 3292 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#else
#define XSubPPtmpAAAP 1


XS_EUPXS(XS_Net__SSH2__Channel_pty); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_pty)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 5)
       croak_xs_usage(cv,  "ch, terminal, modes= NULL, width= 0, height= 0");
    {
	SSH2_CHANNEL*	ch;
	SV*	terminal = ST(1)
;
	SV*	modes;
	int	width;
	int	height;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_pty() - invalid channel object")
;

	if (items < 3)
	    modes = NULL;
	else {
	    modes = ST(2)
;
	}

	if (items < 4)
	    width = 0;
	else {
	    width = (int)SvIV(ST(3))
;
	}

	if (items < 5)
	    height = 0;
	else {
	    height = (int)SvIV(ST(4))
;
	}
#line 1701 "SSH2.xs"
    croak("libssh2 version 1.0 or higher required for PTY support");
#line 3343 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_pty_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_pty_size)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "ch, width= 0, height= 0");
    {
	SSH2_CHANNEL*	ch;
	int	width;
	int	height;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_pty_size() - invalid channel object")
;

	if (items < 2)
	    width = 0;
	else {
	    width = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    height = 0;
	else {
	    height = (int)SvIV(ST(2))
;
	}
#line 1706 "SSH2.xs"
    croak("libssh2 version 1.0 or higher required for PTY support");
#line 3381 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2__Channel_process); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_process)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ch, request, message= NULL");
    {
#line 1713 "SSH2.xs"
    const char* pv_request, * pv_message = NULL;
    STRLEN len_request, len_message = 0;
#line 3398 "SSH2.c"
	SSH2_CHANNEL*	ch;
	SV*	request = ST(1)
;
	SV*	message;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_process() - invalid channel object")
;

	if (items < 3)
	    message = NULL;
	else {
	    message = ST(2)
;
	}
#line 1716 "SSH2.xs"
    pv_request = SvPV(request, len_request);
    if (message && SvPOK(message))
        pv_message = SvPV(message, len_message);

    XSRETURN_IV(!libssh2_channel_process_startup(ch->channel,
     pv_request, len_request, pv_message, len_message));
#line 3423 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_ext_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_ext_data)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ch, mode");
    {
#line 1726 "SSH2.xs"
    IV i_mode;
#line 3438 "SSH2.c"
	SSH2_CHANNEL*	ch;
	SV*	mode = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_ext_data() - invalid channel object")
;
#line 1728 "SSH2.xs"
    if (!iv_constant_sv("LIBSSH2_CHANNEL_EXTENDED_DATA_", mode, &i_mode))
        croak("%s::ext_data: unknown extended data mode: %s",
         class, SvPV_nolen(mode));
    libssh2_channel_handle_extended_data(ch->channel, i_mode);
    XSRETURN_IV(1);
#line 3454 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_read)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "ch, buffer, size, ext= &PL_sv_undef");
    {
#line 1737 "SSH2.xs"
    char* pv_buffer;
    int count, total = 0;
#line 3470 "SSH2.c"
	SSH2_CHANNEL*	ch;
	SV*	buffer = ST(1)
;
	size_t	size = (size_t)SvUV(ST(2))
;
	SV *	ext;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_read() - invalid channel object")
;

	if (items < 4)
	    ext = &PL_sv_undef;
	else {
	    ext = ST(3)
;
	}
#line 1740 "SSH2.xs"
    debug("%s::read(size = %d, ext = %d)\n", class, size, SvTRUE(ext));
    clear_error(ch->ss);
    SvPOK_on(buffer);
    pv_buffer = sv_grow(buffer, size + 1/*NUL*/);  /* force PV */

    again:
    count = libssh2_channel_read_ex(ch->channel, XLATEXT, pv_buffer, size);
    debug("- read %d bytes\n", count);

    if (count < 0) {
        if (!total) {
            SvCUR_set(buffer, 0);
            XSRETURN_EMPTY;
        }
        count = 0;
    }

    total += count;

    if (count > 0 && (unsigned)count < size &&
        libssh2_session_get_blocking(ch->ss->session)) {

        pv_buffer += count;
        size -= count;
        goto again;
    }

    pv_buffer[count] = '\0';
    SvCUR_set(buffer, total);
    debug("- read %d total\n", total);
    XSRETURN_IV(total);
#line 3522 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_write)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ch, buffer, ext= &PL_sv_undef");
    {
#line 1775 "SSH2.xs"
    const char* pv_buffer;
    STRLEN len_buffer, offset = 0;
    int count = 0;
#line 3539 "SSH2.c"
	SV *	RETVAL;
	SSH2_CHANNEL*	ch;
	SV*	buffer = ST(1)
;
	SV *	ext;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_write() - invalid channel object")
;

	if (items < 3)
	    ext = &PL_sv_undef;
	else {
	    ext = ST(2)
;
	}
#line 1779 "SSH2.xs"
    /*
       1. in blocking mode, write all the data.
       2. in non-blocking mode, write as much data as possible without
          blocking.
       3. if some error happens...
          a. if some data was already written, discard the error and
             report the number of bytes written.
          b. if no data was written, report the error.
    */
    clear_error(ch->ss);
    pv_buffer = SvPV(buffer, len_buffer);
    while (offset < len_buffer) {
        count = libssh2_channel_write_ex(ch->channel, XLATEXT,
                                         pv_buffer + offset,
                                         len_buffer - offset);
        if (count >= 0)
            offset += count;
        else if (!((count == LIBSSH2_ERROR_EAGAIN) &&
                   libssh2_session_get_blocking(ch->ss->session)))
            break;
    }
    if (offset || (count == 0)) /* yes, zero is a valid value */
        RETVAL = newSVuv(offset);
    else if (count ==  LIBSSH2_ERROR_EAGAIN)
        RETVAL = newSViv(LIBSSH2_ERROR_EAGAIN);
    else
        RETVAL = &PL_sv_undef;
#line 3586 "SSH2.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#if LIBSSH2_VERSION_NUM >= 0x010100
#define XSubPPtmpAAAQ 1


XS_EUPXS(XS_Net__SSH2__Channel_receive_window_adjust); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_receive_window_adjust)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ch, adjustment, force= &PL_sv_undef");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1814 "SSH2.xs"
    unsigned int new_size;
#line 3608 "SSH2.c"
	SSH2_CHANNEL *	ch;
	unsigned long	adjustment = (unsigned long)SvUV(ST(1))
;
	SV *	force;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_receive_window_adjust() - invalid channel object")
;

	if (items < 3)
	    force = &PL_sv_undef;
	else {
	    force = ST(2)
;
	}
#line 1816 "SSH2.xs"
    if (libssh2_channel_receive_window_adjust2(ch->channel, adjustment,
                                               SvTRUE(force), &new_size) == LIBSSH2_ERROR_NONE) {
        XPUSHs(sv_2mortal(newSVuv(new_size)));
        XSRETURN(1);
    }
    else
        XSRETURN_EMPTY;
#line 3634 "SSH2.c"
	PUTBACK;
	return;
    }
}

#else
#define XSubPPtmpAAAR 1


XS_EUPXS(XS_Net__SSH2__Channel_receive_window_adjust); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_receive_window_adjust)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "ch, ...");
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_receive_window_adjust() - invalid channel object")
;
#line 1829 "SSH2.xs"
    croak("libssh2 version 1.1 or higher required for receive_window_adjust support");
#line 3660 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif
#if LIBSSH2_VERSION_NUM >= 0x010200
#define XSubPPtmpAAAS 1


XS_EUPXS(XS_Net__SSH2__Channel_window_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_window_write)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1838 "SSH2.xs"
    unsigned long window_size_initial = 0;
#line 3681 "SSH2.c"
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_window_write() - invalid channel object")
;
#line 1840 "SSH2.xs"
    XPUSHs(sv_2mortal(newSVuv(libssh2_channel_window_write_ex(ch->channel,
                                                              &window_size_initial))));
    if (GIMME_V == G_ARRAY) {
        XPUSHs(sv_2mortal(newSVuv(window_size_initial)));
        XSRETURN(2);
    }
    else
        XSRETURN(1);
#line 3698 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SSH2__Channel_window_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_window_read)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1852 "SSH2.xs"
    unsigned long read_avail = 0;
    unsigned long window_size_initial = 0;
#line 3717 "SSH2.c"
	SSH2_CHANNEL *	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_window_read() - invalid channel object")
;
#line 1855 "SSH2.xs"
    XPUSHs(sv_2mortal(newSVuv(libssh2_channel_window_read_ex(ch->channel,
                                                             &read_avail,
                                                             &window_size_initial))));
    if (GIMME_V == G_ARRAY) {
        XPUSHs(sv_2mortal(newSVuv(read_avail)));
        XPUSHs(sv_2mortal(newSVuv(window_size_initial)));
        XSRETURN(3);
    }
    else
        XSRETURN(1);
#line 3736 "SSH2.c"
	PUTBACK;
	return;
    }
}

#else
#define XSubPPtmpAAAT 1


XS_EUPXS(XS_Net__SSH2__Channel_window_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_window_write)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_window_write() - invalid channel object")
;
#line 1871 "SSH2.xs"
    croak("libssh2 version 1.2 or higher required for window_write support");
#line 3762 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_window_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_window_read)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_CHANNEL*	ch;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_window_read() - invalid channel object")
;
#line 1876 "SSH2.xs"
    croak("libssh2 version 1.2 or higher required for window_read support");
#line 3784 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2__Channel_flush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_flush)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "ch, ext= &PL_sv_undef");
    {
#line 1883 "SSH2.xs"
    int count;
#line 3800 "SSH2.c"
	SSH2_CHANNEL*	ch;
	SV *	ext;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        ch = (SSH2_CHANNEL *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::Channel::net_ch_flush() - invalid channel object")
;

	if (items < 2)
	    ext = &PL_sv_undef;
	else {
	    ext = ST(1)
;
	}
#line 1885 "SSH2.xs"
    clear_error(ch->ss);
    count = libssh2_channel_flush_ex(ch->channel, XLATEXT);
    if (count < 0)
        XSRETURN_EMPTY;
    XSRETURN_IV(count);
#line 3822 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#undef class
#define class "Net::SSH2::Listener"

XS_EUPXS(XS_Net__SSH2__Listener_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Listener_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ls");
    {
	SSH2_LISTENER*	ls;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ls = (SSH2_LISTENER *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::Listener::net_ls_DESTROY() - invalid listener object")
;
#line 1902 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    clear_error(ls->ss);
    libssh2_channel_forward_cancel(ls->listener);
    SvREFCNT_dec(ls->sv_ss);
    Safefree(ls);
#line 3850 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Listener_accept); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Listener_accept)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ls");
    {
#line 1911 "SSH2.xs"
    SSH2* ss;
#line 3865 "SSH2.c"
	SSH2_CHANNEL *	RETVAL;
	SSH2_LISTENER*	ls;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        ls = (SSH2_LISTENER *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::Listener::net_ls_accept() - invalid listener object")
;
#line 1913 "SSH2.xs"
    clear_error(ss = ls->ss);
    NEW_CHANNEL(libssh2_channel_forward_accept(ls->listener));
#line 3877 "SSH2.c"
	ST(0) = sv_newmortal();
    {
    GV* gv = (GV*)newSVrv(ST(0), "Net::SSH2::Channel");
    IO* io = (IO*)newSV(0);
    const char* name = form("_GEN_%ld", (long)net_ch_gensym++);
    SvUPGRADE((SV*)gv, SVt_PVGV);
    SvUPGRADE((SV*)io, SVt_PVIO);
    gv_init(gv, gv_stashpv("Net::SSH2::Channel", 0/*create*/),
     name, strlen(name), 0/*multi*/);
    GvSV(gv) = newSViv(PTR2IV(RETVAL));
    GvIOp(gv) = io;
    if (PERL_VERSION > 6) {
      sv_magic((SV*)io, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    } else {
      sv_magic((SV*)gv, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    }
    }
    }
    XSRETURN(1);
}

#undef class
#define class "Net::SSH2::SFTP"

XS_EUPXS(XS_Net__SSH2__SFTP_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sf");
    {
	SSH2_SFTP*	sf;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_DESTROY() - invalid SFTP object")
;
#line 1929 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    clear_error(sf->ss);
    libssh2_sftp_shutdown(sf->sftp);
    debug("%s::DESTROY freeing session\n", class);
    SvREFCNT_dec(sf->sv_ss);
    Safefree(sf);
#line 3923 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__SFTP_session); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_session)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sf");
    {
	SSH2_SFTP*	sf;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_session() - invalid SFTP object")
;
#line 1939 "SSH2.xs"
    ST(0) = sv_2mortal(newRV_inc(sf->sv_ss));
    XSRETURN(1);
#line 3946 "SSH2.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__SFTP_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_error)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sf");
    {
#line 1945 "SSH2.xs"
    unsigned long error;
#line 3961 "SSH2.c"
	SSH2_SFTP*	sf;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_error() - invalid SFTP object")
;
#line 1947 "SSH2.xs"
    error = libssh2_sftp_last_error(sf->sftp);
    switch (GIMME_V) {
    case G_SCALAR:
        XSRETURN_UV(error);
    case G_ARRAY:
        EXTEND(SP, 2);
        ST(0) = sv_2mortal(newSVuv(error));
        if (error < countof(sftp_error))
            ST(1) = sv_2mortal(newSVpvf("SSH_FX_%s", sftp_error[error]));
        else
            ST(1) = sv_2mortal(newSVpvf("SSH_FX_UNKNOWN(%lu)", error));
        XSRETURN(2);
    }
#line 3983 "SSH2.c"
    }
    XSRETURN(1);
}

#define XLATFLAG(posix, fxf) do { \
    if (flags & posix || \
     l_flags == 0 && posix == 0 && flags == posix /* 0-valued flag */) { \
        l_flags |= fxf; \
        flags &= ~posix; \
    } \
} while(0)

XS_EUPXS(XS_Net__SSH2__SFTP_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_open)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "sf, file, flags= O_RDONLY, mode= 0666");
    {
#line 1972 "SSH2.xs"
    long l_flags = 0;
    const char* pv_file;
    STRLEN len_file;
#line 4007 "SSH2.c"
	SSH2_FILE *	RETVAL;
	SSH2_SFTP*	sf;
	SV*	file = ST(1)
;
	int	flags;
	int	mode;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_open() - invalid SFTP object")
;

	if (items < 3)
	    flags = O_RDONLY;
	else {
	    flags = (int)SvIV(ST(2))
;
	}

	if (items < 4)
	    mode = 0666;
	else {
	    mode = (int)SvIV(ST(3))
;
	}
#line 1976 "SSH2.xs"
    clear_error(sf->ss);
    pv_file = SvPV(file, len_file);

    /* map POSIX O_* to LIBSSH2_FXF_* (can't assume they're the same) */
    XLATFLAG(O_RDWR,   LIBSSH2_FXF_READ | LIBSSH2_FXF_WRITE);
    XLATFLAG(O_RDONLY, LIBSSH2_FXF_READ);
    XLATFLAG(O_WRONLY, LIBSSH2_FXF_WRITE);
    XLATFLAG(O_APPEND, LIBSSH2_FXF_APPEND);
    XLATFLAG(O_CREAT,  LIBSSH2_FXF_CREAT);
    XLATFLAG(O_TRUNC,  LIBSSH2_FXF_TRUNC);
    XLATFLAG(O_EXCL,   LIBSSH2_FXF_EXCL);
    if (flags)
        croak("%s::open: unknown flag value: %d", class, flags);

    NEW_FILE(libssh2_sftp_open_ex(sf->sftp, (char*)pv_file, len_file,
     l_flags, mode, LIBSSH2_SFTP_OPENFILE));
#line 4051 "SSH2.c"
	ST(0) = sv_newmortal();
    {
    GV* gv = (GV*)newSVrv(ST(0), "Net::SSH2::File");
    IO* io = (IO*)newSV(0);
    const char* name = form("_GEN_%ld", (long)net_fi_gensym++);
    SvUPGRADE((SV*)gv, SVt_PVGV);
    SvUPGRADE((SV*)io, SVt_PVIO);
    gv_init(gv, gv_stashpv("Net::SSH2::File", 0/*create*/),
     name, strlen(name), 0/*multi*/);
    GvSV(gv) = newSViv(PTR2IV(RETVAL));
    GvIOp(gv) = io;
    if (PERL_VERSION > 6) {
      sv_magic((SV*)io, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    } else {
      sv_magic((SV*)gv, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
    }
    }
    }
    XSRETURN(1);
}

#undef XLATFLAG

XS_EUPXS(XS_Net__SSH2__SFTP_opendir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_opendir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sf, dir");
    {
#line 2000 "SSH2.xs"
    const char* pv_dir;
    STRLEN len_dir;
#line 4085 "SSH2.c"
	SSH2_DIR *	RETVAL;
	SSH2_SFTP*	sf;
	SV*	dir = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_opendir() - invalid SFTP object")
;
#line 2003 "SSH2.xs"
    clear_error(sf->ss);
    pv_dir = SvPV(dir, len_dir);
    NEW_DIR(libssh2_sftp_open_ex(sf->sftp, (char*)pv_dir, len_dir,
     0/*flags*/, 0/*mode*/, LIBSSH2_SFTP_OPENDIR));
#line 4101 "SSH2.c"
	ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), "Net::SSH2::Dir", (void *)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__SFTP_unlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_unlink)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sf, file");
    {
#line 2013 "SSH2.xs"
    const char* pv_file;
    STRLEN len_file;
#line 4119 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	file = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_unlink() - invalid SFTP object")
;
#line 2016 "SSH2.xs"
    clear_error(sf->ss);
    pv_file = SvPV(file, len_file);
    XSRETURN_IV(!libssh2_sftp_unlink_ex(sf->sftp, (char*)pv_file, len_file));
#line 4133 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__SFTP_rename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_rename)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "sf, old, new, flags= LIBSSH2_SFTP_RENAME_OVERWRITE |  LIBSSH2_SFTP_RENAME_ATOMIC | LIBSSH2_SFTP_RENAME_NATIVE");
    {
#line 2025 "SSH2.xs"
    const char* pv_old, * pv_new;
    STRLEN len_old, len_new;
#line 4149 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	old = ST(1)
;
	SV*	new = ST(2)
;
	long	flags;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_rename() - invalid SFTP object")
;

	if (items < 4)
	    flags = LIBSSH2_SFTP_RENAME_OVERWRITE |  LIBSSH2_SFTP_RENAME_ATOMIC | LIBSSH2_SFTP_RENAME_NATIVE;
	else {
	    flags = (long)SvIV(ST(3))
;
	}
#line 2028 "SSH2.xs"
    clear_error(sf->ss);
    pv_old = SvPV(old, len_old);
    pv_new = SvPV(new, len_new);
    XSRETURN_IV(!libssh2_sftp_rename_ex(sf->sftp,
     (char*)pv_old, len_old, (char*)pv_new, len_new, flags));
#line 4175 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__SFTP_mkdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_mkdir)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "sf, dir, mode= 0777");
    {
#line 2037 "SSH2.xs"
    const char* pv_dir;
    STRLEN len_dir;
#line 4191 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	dir = ST(1)
;
	int	mode;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_mkdir() - invalid SFTP object")
;

	if (items < 3)
	    mode = 0777;
	else {
	    mode = (int)SvIV(ST(2))
;
	}
#line 2040 "SSH2.xs"
    clear_error(sf->ss);
    pv_dir = SvPV(dir, len_dir);
    XSRETURN_IV(!libssh2_sftp_mkdir_ex(sf->sftp, (char*)pv_dir, len_dir, mode));
#line 4213 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__SFTP_rmdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_rmdir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sf, dir");
    {
#line 2047 "SSH2.xs"
    const char* pv_dir;
    STRLEN len_dir;
#line 4229 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	dir = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_rmdir() - invalid SFTP object")
;
#line 2050 "SSH2.xs"
    clear_error(sf->ss);
    pv_dir = SvPV(dir, len_dir);
    XSRETURN_IV(!libssh2_sftp_rmdir_ex(sf->sftp, (char*)pv_dir, len_dir));
#line 4243 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__SFTP_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_stat)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "sf, path, follow= 1");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2057 "SSH2.xs"
    const char* pv_path;
    STRLEN len_path;
    int success;
    LIBSSH2_SFTP_ATTRIBUTES attrs;
#line 4263 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	path = ST(1)
;
	int	follow;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_stat() - invalid SFTP object")
;

	if (items < 3)
	    follow = 1;
	else {
	    follow = (int)SvIV(ST(2))
;
	}
#line 2062 "SSH2.xs"
    clear_error(sf->ss);
    pv_path = SvPV(path, len_path);
    success = !libssh2_sftp_stat_ex(sf->sftp, (char*)pv_path, len_path,
     follow ? LIBSSH2_SFTP_STAT : LIBSSH2_SFTP_LSTAT, &attrs);
    if (!success)
        XSRETURN_EMPTY;
    XSRETURN_STAT_ATTRS(SvREFCNT_inc(path));
#line 4289 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SSH2__SFTP_setstat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_setstat)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "sf, path, ...");
    {
#line 2073 "SSH2.xs"
    const char* pv_path;
    STRLEN len_path;
    LIBSSH2_SFTP_ATTRIBUTES attrs;
    int i;
#line 4308 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	path = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_setstat() - invalid SFTP object")
;
#line 2078 "SSH2.xs"
    clear_error(sf->ss);
    pv_path = SvPV(path, len_path);
    Zero(&attrs, 1, LIBSSH2_SFTP_ATTRIBUTES);

    /* read key/value pairs; cf. hv_from_attrs */
    for (i = 2; i < items; i += 2) {
        const char* key = SvPV_nolen(ST(i));
        if (i + 1 == items)
            croak("%s::setstat: key without value", class);
        if (0);  /* prime the chain */
        XLATATTR("size",  filesize,    SIZE)
        XLATATTR("uid",   uid,         UIDGID)
        XLATATTR("gid",   gid,         UIDGID)
        XLATATTR("mode",  permissions, PERMISSIONS)
        XLATATTR("atime", atime,       ACMODTIME)
        XLATATTR("mtime", mtime,       ACMODTIME)
        else
            croak("%s::setstat: unknown attribute: %s", class, key);
    }

    XSRETURN_IV(!libssh2_sftp_stat_ex(sf->sftp, (char*)pv_path, len_path,
     LIBSSH2_SFTP_SETSTAT, &attrs));
#line 4341 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__SFTP_symlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_symlink)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "sf, path, target");
    {
#line 2104 "SSH2.xs"
    const char* pv_path, * pv_target;
    STRLEN len_path, len_target;
#line 4357 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	path = ST(1)
;
	SV*	target = ST(2)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_symlink() - invalid SFTP object")
;
#line 2107 "SSH2.xs"
    clear_error(sf->ss);
    pv_path = SvPV(path, len_path);
    pv_target = SvPV(target, len_target);
    XSRETURN_IV(!libssh2_sftp_symlink_ex(sf->sftp,
     pv_path, len_path, (char*)pv_target, len_target, LIBSSH2_SFTP_SYMLINK));
#line 4375 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__SFTP_readlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_readlink)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sf, path");
    {
#line 2116 "SSH2.xs"
    SV* link;
    const char* pv_path;
    char* pv_link;
    STRLEN len_path;
    int count;
#line 4394 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	path = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_readlink() - invalid SFTP object")
;
#line 2122 "SSH2.xs"
    clear_error(sf->ss);
    pv_path = SvPV(path, len_path);
    link = newSV(MAXPATHLEN + 1);
    SvPOK_on(link);
    pv_link = SvPVX(link);

    count = libssh2_sftp_symlink_ex(sf->sftp,
     pv_path, len_path, pv_link, MAXPATHLEN, LIBSSH2_SFTP_READLINK);

    if (count < 0) {
        SvREFCNT_dec(link);
        XSRETURN_EMPTY;
    }
    pv_link[count] = '\0';
    SvCUR_set(link, count);
    ST(0) = sv_2mortal(link);
    XSRETURN(1);
#line 4422 "SSH2.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__SFTP_realpath); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_realpath)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sf, path");
    {
#line 2143 "SSH2.xs"
    SV* real;
    const char* pv_path;
    char* pv_real;
    STRLEN len_path;
    int count;
#line 4441 "SSH2.c"
	SSH2_SFTP*	sf;
	SV*	path = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sf = (SSH2_SFTP *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::SFTP::net_sf_realpath() - invalid SFTP object")
;
#line 2149 "SSH2.xs"
    clear_error(sf->ss);
    pv_path = SvPV(path, len_path);
    real = newSV(MAXPATHLEN + 1);
    SvPOK_on(real);
    pv_real = SvPVX(real);

    count = libssh2_sftp_symlink_ex(sf->sftp,
     pv_path, len_path, pv_real, MAXPATHLEN, LIBSSH2_SFTP_REALPATH);

    if (count < 0) {
        SvREFCNT_dec(real);
        XSRETURN_EMPTY;
    }
    pv_real[count] = '\0';
    SvCUR_set(real, count);
    ST(0) = sv_2mortal(real);
    XSRETURN(1);
#line 4469 "SSH2.c"
    }
    XSRETURN(1);
}

#undef class
#define class "Net::SSH2::File"

XS_EUPXS(XS_Net__SSH2__File_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fi");
    {
	SSH2_FILE*	fi;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        fi = (SSH2_FILE *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::File::net_fi_DESTROY() - invalid SFTP file object")
;
#line 2178 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    clear_error(fi->sf->ss);
    libssh2_sftp_close_handle(fi->handle);
    SvREFCNT_dec(fi->sv_sf);
    Safefree(fi);
#line 4497 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__File_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_read)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fi, buffer, size");
    {
#line 2187 "SSH2.xs"
    char* pv_buffer;
    int count;
#line 4513 "SSH2.c"
	SSH2_FILE*	fi;
	SV*	buffer = ST(1)
;
	size_t	size = (size_t)SvUV(ST(2))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        fi = (SSH2_FILE *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::File::net_fi_read() - invalid SFTP file object")
;
#line 2190 "SSH2.xs"
    clear_error(fi->sf->ss);
    SvPOK_on(buffer);
    pv_buffer = sv_grow(buffer, size + 1/*NUL*/);  /* force PV */
    pv_buffer[size] = '\0';

    count = libssh2_sftp_read(fi->handle, pv_buffer, size);
    if (count < 0) {
        SvCUR_set(buffer, 0);
        XSRETURN_EMPTY;
    }
    SvCUR_set(buffer, count);
    XSRETURN_IV(count);
#line 4538 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__File_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_write)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fi, buffer");
    {
#line 2206 "SSH2.xs"
    const char* pv_buffer;
    STRLEN len_buffer;
    ssize_t count;
#line 4555 "SSH2.c"
	SSH2_FILE*	fi;
	SV*	buffer = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        fi = (SSH2_FILE *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::File::net_fi_write() - invalid SFTP file object")
;
#line 2210 "SSH2.xs"
    clear_error(fi->sf->ss);
    pv_buffer = SvPV(buffer, len_buffer);
    count = libssh2_sftp_write(fi->handle, pv_buffer, len_buffer);
    if (count < 0)
        XSRETURN_EMPTY;
    XSRETURN_UV(count);    
#line 4572 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__File_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_stat)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fi");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2220 "SSH2.xs"
    LIBSSH2_SFTP_ATTRIBUTES attrs;
#line 4589 "SSH2.c"
	SSH2_FILE*	fi;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        fi = (SSH2_FILE *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::File::net_fi_stat() - invalid SFTP file object")
;
#line 2222 "SSH2.xs"
    clear_error(fi->sf->ss);
    if (libssh2_sftp_fstat(fi->handle, &attrs))
        XSRETURN_EMPTY;
    XSRETURN_STAT_ATTRS(NULL/*name*/);
#line 4602 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SSH2__File_setstat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_setstat)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "fi, ...");
    {
#line 2230 "SSH2.xs"
    LIBSSH2_SFTP_ATTRIBUTES attrs;
    int i;
#line 4619 "SSH2.c"
	SSH2_FILE*	fi;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        fi = (SSH2_FILE *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::File::net_fi_setstat() - invalid SFTP file object")
;
#line 2233 "SSH2.xs"
    clear_error(fi->sf->ss);
    Zero(&attrs, 1, LIBSSH2_SFTP_ATTRIBUTES);

    /* read key/value pairs; cf. hv_from_attrs */
    for (i = 1; i < items; i += 2) {
        const char* key = SvPV_nolen(ST(i));
        if (i + 1 == items)
            croak("%s::setstat: key without value", class);
        if (0);  /* prime the chain */
        XLATATTR("size",  filesize,    SIZE)
        XLATATTR("uid",   uid,         UIDGID)
        XLATATTR("gid",   gid,         UIDGID)
        XLATATTR("mode",  permissions, PERMISSIONS)
        XLATATTR("atime", atime,       ACMODTIME)
        XLATATTR("mtime", mtime,       ACMODTIME)
        else
            croak("%s::setstat: unknown attribute: %s", class, key);
    }

    XSRETURN_IV(!libssh2_sftp_fsetstat(fi->handle, &attrs));
#line 4648 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__File_seek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_seek)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fi, offset");
    {
	SSH2_FILE*	fi;
	size_t	offset = (size_t)SvUV(ST(1))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        fi = (SSH2_FILE *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::File::net_fi_seek() - invalid SFTP file object")
;
#line 2257 "SSH2.xs"
    clear_error(fi->sf->ss);
    libssh2_sftp_seek(fi->handle, offset);
    XSRETURN(1);
#line 4674 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__File_tell); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_tell)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fi");
    {
	SSH2_FILE*	fi;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVGV))
        fi = (SSH2_FILE *)SvIVX(GvSV((GV*)SvRV(ST(0))));
    else
        croak("Net::SSH2::File::net_fi_tell() - invalid SFTP file object")
;
#line 2264 "SSH2.xs"
    clear_error(fi->sf->ss);
    XSRETURN_UV(libssh2_sftp_tell(fi->handle));
#line 4697 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#undef class
#define class "Net::SSH2::Dir"

XS_EUPXS(XS_Net__SSH2__Dir_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Dir_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "di");
    {
	SSH2_DIR*	di;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        di = (SSH2_DIR *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::Dir::net_di_DESTROY() - invalid SFTP directory object")
;
#line 2278 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    clear_error(di->sf->ss);
    libssh2_sftp_close_handle(di->handle);
    SvREFCNT_dec(di->sv_sf);
    Safefree(di);
#line 4725 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Dir_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Dir_read)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "di");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2287 "SSH2.xs"
    SV* buffer;
    char* pv_buffer;
    int count;
    LIBSSH2_SFTP_ATTRIBUTES attrs;
#line 4745 "SSH2.c"
	SSH2_DIR*	di;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        di = (SSH2_DIR *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::Dir::net_di_read() - invalid SFTP directory object")
;
#line 2292 "SSH2.xs"
    clear_error(di->sf->ss);
    buffer = newSV(MAXPATHLEN + 1);
    SvPOK_on(buffer);
    pv_buffer = SvPVX(buffer);

    count = libssh2_sftp_readdir(di->handle, pv_buffer, MAXPATHLEN, &attrs);

    if (count <= 0) {
        SvREFCNT_dec(buffer);
        XSRETURN_EMPTY;
    }
    pv_buffer[count] = '\0';
    SvCUR_set(buffer, count);
    XSRETURN_STAT_ATTRS(buffer);
#line 4768 "SSH2.c"
	PUTBACK;
	return;
    }
}

#undef class
#define class "Net::SSH2::PublicKey"

XS_EUPXS(XS_Net__SSH2__PublicKey_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__PublicKey_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pk");
    {
	SSH2_PUBLICKEY*	pk;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pk = (SSH2_PUBLICKEY *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::PublicKey::net_pk_DESTROY() - invalid public key object")
;
#line 2318 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    clear_error(pk->ss);
    libssh2_publickey_shutdown(pk->pkey);
    SvREFCNT_dec(pk->sv_ss);
    Safefree(pk);
#line 4797 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__PublicKey_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__PublicKey_add)
{
    dVAR; dXSARGS;
    if (items < 4)
       croak_xs_usage(cv,  "pk, name, blob, overwrite, ...");
    {
#line 2327 "SSH2.xs"
    int success;
    const char* pv_name, * pv_blob;
    STRLEN len_name, len_blob;
    unsigned long num_attrs, i;
    libssh2_publickey_attribute *attrs;
#line 4816 "SSH2.c"
	SSH2_PUBLICKEY*	pk;
	SV*	name = ST(1)
;
	SV*	blob = ST(2)
;
	int	overwrite = (int)SvIV(ST(3))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pk = (SSH2_PUBLICKEY *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::PublicKey::net_pk_add() - invalid public key object")
;
#line 2333 "SSH2.xs"
    clear_error(pk->ss);
    pv_name = SvPV(name, len_name);
    pv_blob = SvPV(blob, len_blob);

    num_attrs = items - 4;
    New(0, attrs, num_attrs, libssh2_publickey_attribute);
    if (!attrs) {
        set_error(pk->ss, 0, "out of memory allocating attribute structures");
        XSRETURN_EMPTY;
    }
    for (i = 0; i < num_attrs; ++i) {
        HV* hv;
        SV** tmp;
        STRLEN len_tmp;

        if (!SvROK(ST(i + 4)) || SvTYPE(SvRV(ST(i + 4))) != SVt_PVHV)
            croak("%s::add: attribute %lu is not hash", class, i);
        hv = (HV*)SvRV(ST(i + 4));

        if (!(tmp = hv_fetch(hv, "name", 4, 0/*lval*/)) || !*tmp)
            croak("%s::add: attribute %lu missing name", class, i);
        attrs[i].name = SvPV(*tmp, len_tmp);
        attrs[i].name_len = len_tmp;

        if ((tmp = hv_fetch(hv, "value", 5, 0/*lval*/)) && *tmp) {
            attrs[i].value = SvPV(*tmp, len_tmp);
            attrs[i].value_len = len_tmp;
        } else
            attrs[i].value_len = 0;

        if ((tmp = hv_fetch(hv, "mandatory", 9, 0/*lval*/)) && *tmp)
            attrs[i].mandatory = (char)SvIV(*tmp);
        else
            attrs[i].mandatory = 0;
    }

    success = !libssh2_publickey_add_ex(pk->pkey,
     (const unsigned char *)pv_name, len_name,
     (const unsigned char *)pv_blob, len_blob, overwrite, num_attrs, attrs);

    Safefree(attrs);
    XSRETURN_IV(!success);
#line 4873 "SSH2.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__PublicKey_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__PublicKey_remove)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "pk, name, blob");
    {
#line 2379 "SSH2.xs"
    const char* pv_name, * pv_blob;
    STRLEN len_name, len_blob;
#line 4889 "SSH2.c"
	SSH2_PUBLICKEY*	pk;
	SV*	name = ST(1)
;
	SV*	blob = ST(2)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pk = (SSH2_PUBLICKEY *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::PublicKey::net_pk_remove() - invalid public key object")
;
#line 2382 "SSH2.xs"
    clear_error(pk->ss);
    pv_name = SvPV(name, len_name);
    pv_blob = SvPV(blob, len_blob);
    XSRETURN_IV(!libssh2_publickey_remove_ex(pk->pkey,
     (const unsigned char *)pv_name, len_name,
     (const unsigned char *)pv_blob, len_blob));
#line 4908 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__PublicKey_fetch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__PublicKey_fetch)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pk");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2392 "SSH2.xs"
    unsigned long keys, i, j;
    libssh2_publickey_list* list = NULL;
#line 4926 "SSH2.c"
	SSH2_PUBLICKEY*	pk;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pk = (SSH2_PUBLICKEY *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::PublicKey::net_pk_fetch() - invalid public key object")
;
#line 2395 "SSH2.xs"
    if (!libssh2_publickey_list_fetch(pk->pkey, &keys, &list) || !list)
        XSRETURN_EMPTY;

    if (GIMME_V == G_ARRAY) {
        EXTEND(SP, keys);

        for (i = 0; i < keys; ++i) {
            HV* hv = newHV();
            AV* av = newAV();

            hv_store(hv, "name", 4,
             newSVpvn((char*)list[i].name, list[i].name_len), 0/*hash*/);
            hv_store(hv, "blob", 4,
             newSVpvn((char*)list[i].blob, list[i].blob_len), 0/*hash*/);

            hv_store(hv, "attr", 4, newRV_noinc((SV*)av), 0/*hash*/);
            av_extend(av, list[i].num_attrs - 1);
            for (j = 0; j < list[i].num_attrs; ++j) {
                HV* attr = newHV();
                hv_store(attr, "name", 4, newSVpvn(list[i].attrs[j].name,
                 list[i].attrs[j].name_len), 0/*hash*/);
                hv_store(attr, "value", 5, newSVpvn(list[i].attrs[j].value,
                 list[i].attrs[j].value_len), 0/*hash*/);
                hv_store(attr, "mandatory", 9,
                 newSViv(list[i].attrs[j].mandatory), 0/*hash*/);
                av_store(av, j, newRV_noinc((SV*)attr));
            }

            ST(i) = sv_2mortal(newRV_noinc((SV*)hv));
        }
    }

    libssh2_publickey_list_free(pk->pkey, list);

    if (GIMME_V == G_ARRAY)
        XSRETURN(keys);
    XSRETURN_UV(keys);
#line 4972 "SSH2.c"
	PUTBACK;
	return;
    }
}

#undef class
#define class "Net::SSH2::KnownHosts"
#if LIBSSH2_VERSION_NUM >= 0x010200
#define XSubPPtmpAAAU 1


XS_EUPXS(XS_Net__SSH2__KnownHosts_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__KnownHosts_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "kh");
    {
	SSH2_KNOWNHOSTS *	kh;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        kh = (SSH2_KNOWNHOSTS *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::KnownHosts::net_kh_DESTROY() - invalid knownhost object")
;
#line 2445 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    clear_error(kh->ss);
    libssh2_knownhost_free(kh->knownhosts);
    SvREFCNT_dec(kh->sv_ss);
    Safefree(kh);
#line 5004 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__KnownHosts_readfile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__KnownHosts_readfile)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "kh, filename");
    {
#line 2454 "SSH2.xs"
    int n;
#line 5019 "SSH2.c"
	SSH2_KNOWNHOSTS *	kh;
	const char *    filename = (const char *)SvPV_nolen(ST(1))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        kh = (SSH2_KNOWNHOSTS *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::KnownHosts::net_kh_readfile() - invalid knownhost object")
;
#line 2456 "SSH2.xs"
    clear_error(kh->ss);
    n = libssh2_knownhost_readfile(kh->knownhosts, filename, LIBSSH2_KNOWNHOST_FILE_OPENSSH);
    if (n >= 0)
        XSRETURN_IV(n);
    else
        CROAK_LAST_ERROR(kh->ss, "readfile");
#line 5036 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__KnownHosts_writefile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__KnownHosts_writefile)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "kh, filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2466 "SSH2.xs"
    int rc;
#line 5053 "SSH2.c"
	SSH2_KNOWNHOSTS *	kh;
	const char *    filename = (const char *)SvPV_nolen(ST(1))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        kh = (SSH2_KNOWNHOSTS *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::KnownHosts::net_kh_writefile() - invalid knownhost object")
;
#line 2468 "SSH2.xs"
    clear_error(kh->ss);
    rc = libssh2_knownhost_writefile(kh->knownhosts, filename, LIBSSH2_KNOWNHOST_FILE_OPENSSH);
    if (rc == LIBSSH2_ERROR_NONE) {
        XPUSHs(&PL_sv_yes);
        XSRETURN(1);
    }
    else
        CROAK_LAST_ERROR(kh->ss, "writefile");
#line 5072 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SSH2__KnownHosts_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__KnownHosts_add)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "kh, host, salt, key, comment, typemask");
    {
#line 2480 "SSH2.xs"
    int rc;
    STRLEN key_len, comment_len;
    const char *key_pv, *comment_pv;
#line 5090 "SSH2.c"
	SSH2_KNOWNHOSTS *	kh;
	const char *    host = (const char *)SvPV_nolen(ST(1))
;
	const char *    salt = (const char *)SvPV_nolen(ST(2))
;
	SV *	key = ST(3)
;
	SV *	comment = ST(4)
;
	int	typemask = (int)SvIV(ST(5))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        kh = (SSH2_KNOWNHOSTS *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::KnownHosts::net_kh_add() - invalid knownhost object")
;
#line 2484 "SSH2.xs"
    clear_error(kh->ss);
    key_pv = SvPV_const(key, key_len);
    if (SvOK(comment))
        comment_pv = SvPV_const(comment, comment_len);
    else {
        comment_pv = NULL;
        comment_len = 0;
    }
#if LIBSSH2_VERSION_NUM >= 0x010205
    rc = libssh2_knownhost_addc(kh->knownhosts, host, salt, key_pv, key_len,
                                     comment_pv, comment_len, typemask, NULL);
#else
    if (SvOK(comment))
        croak("libssh2 version 1.2.5 is required to add keys with comments");
    rc = libssh2_knownhost_add(kh->knownhosts, host, salt, key_pv, key_len, typemask, NULL);
#endif
    if (rc == LIBSSH2_ERROR_NONE) {
        XPUSHs(&PL_sv_yes);
        XSRETURN(1);
    }
    else
        CROAK_LAST_ERROR(kh->ss, "add");
#line 5131 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__KnownHosts_check); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__KnownHosts_check)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "kh, host, port, key, typemask");
    {
#line 2510 "SSH2.xs"
    STRLEN key_len;
    const char *key_pv;
    UV port_uv;
#line 5148 "SSH2.c"
	int	RETVAL;
	dXSTARG;
	SSH2_KNOWNHOSTS *	kh;
	const char *    host = (const char *)SvPV_nolen(ST(1))
;
	SV *	port = ST(2)
;
	SV *	key = ST(3)
;
	int	typemask = (int)SvIV(ST(4))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        kh = (SSH2_KNOWNHOSTS *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::KnownHosts::net_kh_check() - invalid knownhost object")
;
#line 2514 "SSH2.xs"
    clear_error(kh->ss);
    key_pv = SvPV_const(key, key_len);
    port_uv = (SvOK(port) ? SvUV(port) : 0);
#if LIBSSH2_VERSION_NUM >= 0x010206
    RETVAL = libssh2_knownhost_checkp(kh->knownhosts, host, port_uv,
                                      key_pv, key_len, typemask, NULL);
#else
    if ((port != 0) && (port != 22))
        croak("libssh2 version 1.2.6 is required when using a custom TCP port");
    RETVAL = libssh2_knownhost_check(kh->knownhosts, host,
                                     key_pv, key_len, typemask, NULL);
#endif
#line 5179 "SSH2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__KnownHosts_readline); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__KnownHosts_readline)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "kh, line");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2532 "SSH2.xs"
    int rc;
    STRLEN line_len;
    const char *line_pv;
#line 5199 "SSH2.c"
	SSH2_KNOWNHOSTS *	kh;
	SV *	line = ST(1)
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        kh = (SSH2_KNOWNHOSTS *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::KnownHosts::net_kh_readline() - invalid knownhost object")
;
#line 2536 "SSH2.xs"
    line_pv = SvPV_const(line, line_len);
    rc = libssh2_knownhost_readline(kh->knownhosts, line_pv, line_len, LIBSSH2_KNOWNHOST_FILE_OPENSSH);
    if (rc == LIBSSH2_ERROR_NONE) {
        XPUSHs(&PL_sv_yes);
        XSRETURN(1);
    }
    else
        CROAK_LAST_ERROR(kh->ss, "readline");
#line 5218 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SSH2__KnownHosts_writeline); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__KnownHosts_writeline)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "kh, host, port, key, typemask");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2548 "SSH2.xs"
    int rc;
    STRLEN key_len;
    const char *key_pv;
    UV port_uv;
    size_t line_len;
    STRLEN buffer_len;
    SV *buffer;
    struct libssh2_knownhost *entry = NULL;
#line 5243 "SSH2.c"
	SSH2_KNOWNHOSTS *	kh;
	const char *    host = (const char *)SvPV_nolen(ST(1))
;
	SV *	port = ST(2)
;
	SV *	key = ST(3)
;
	int	typemask = (int)SvIV(ST(4))
;

    if(sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        kh = (SSH2_KNOWNHOSTS *)SvIV((SV*)SvRV(ST(0)));
    else
        croak("Net::SSH2::KnownHosts::net_kh_writeline() - invalid knownhost object")
;
#line 2557 "SSH2.xs"
    clear_error(kh->ss);
    key_pv = SvPV_const(key, key_len);
    port_uv = (SvOK(port) ? SvUV(port) : 0);
#if LIBSSH2_VERSION_NUM >= 0x010206
    rc = libssh2_knownhost_checkp(kh->knownhosts, host, port_uv,
                                      key_pv, key_len, typemask, &entry);
#else
    if ((port != 0) && (port != 22))
        croak("libssh2 version 1.2.6 is required when using a custom TCP port");
    rc = libssh2_knownhost_check(kh->knownhosts, host,
                                 key_pv, key_len, typemask, &entry);
#endif
    if ((rc != LIBSSH2_KNOWNHOST_CHECK_MATCH) || !entry) {
#if LIBSSH2_VERSION_NUM >= 0x010403
        set_error(kh->ss, LIBSSH2_ERROR_KNOWN_HOSTS, "matching host key not found");        
#else
        set_error(kh->ss, LIBSSH2_ERROR_SOCKET_NONE, "matching host key not found");
#endif
    }
    else {
        buffer = sv_2mortal(newSV(512));
        SvPOK_on(buffer);
        while (1) {
            rc = libssh2_knownhost_writeline(kh->knownhosts, entry,
                                             SvPVX(buffer), SvLEN(buffer),
                                             &line_len, LIBSSH2_KNOWNHOST_FILE_OPENSSH);
            if (rc == LIBSSH2_ERROR_NONE) {
                SvPVX(buffer)[line_len] = '\0';
                SvCUR_set(buffer, line_len);
                XPUSHs(buffer);
                XSRETURN(1);
            }

            if ((rc != LIBSSH2_ERROR_BUFFER_TOO_SMALL) ||
                (SvLEN(buffer) > 64 * 1024)) break;

            SvGROW(buffer, SvLEN(buffer) * 2);
        }
    }
    CROAK_LAST_ERROR(kh->ss, "writeline");
#line 5300 "SSH2.c"
	PUTBACK;
	return;
    }
}

#endif
#undef class
#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Net__SSH2); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__SSH2)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        newXS("Net::SSH2::constant", XS_Net__SSH2_constant, file);
        newXS("Net::SSH2::CLONE", XS_Net__SSH2_CLONE, file);
        newXS("Net::SSH2::_new", XS_Net__SSH2__new, file);
        newXS("Net::SSH2::trace", XS_Net__SSH2_trace, file);
#if XSubPPtmpAAAA
        newXS("Net::SSH2::block_directions", XS_Net__SSH2_block_directions, file);
#endif
#if XSubPPtmpAAAB
        newXS("Net::SSH2::block_directions", XS_Net__SSH2_block_directions, file);
#endif
#if XSubPPtmpAAAC
        newXS("Net::SSH2::timeout", XS_Net__SSH2_timeout, file);
#endif
#if XSubPPtmpAAAD
        newXS("Net::SSH2::timeout", XS_Net__SSH2_timeout, file);
#endif
        newXS("Net::SSH2::blocking", XS_Net__SSH2_blocking, file);
        newXS("Net::SSH2::DESTROY", XS_Net__SSH2_DESTROY, file);
        newXS("Net::SSH2::debug", XS_Net__SSH2_debug, file);
        newXS("Net::SSH2::version", XS_Net__SSH2_version, file);
        newXS("Net::SSH2::banner", XS_Net__SSH2_banner, file);
        newXS("Net::SSH2::error", XS_Net__SSH2_error, file);
        newXS("Net::SSH2::method", XS_Net__SSH2_method, file);
#if XSubPPtmpAAAE
        newXS("Net::SSH2::flag", XS_Net__SSH2_flag, file);
#endif
#if XSubPPtmpAAAF
        newXS("Net::SSH2::flag", XS_Net__SSH2_flag, file);
#endif
        newXS("Net::SSH2::callback", XS_Net__SSH2_callback, file);
        newXS("Net::SSH2::_startup", XS_Net__SSH2__startup, file);
        newXS("Net::SSH2::sock", XS_Net__SSH2_sock, file);
        newXS("Net::SSH2::disconnect", XS_Net__SSH2_disconnect, file);
        newXS("Net::SSH2::hostkey_hash", XS_Net__SSH2_hostkey_hash, file);
        newXS("Net::SSH2::remote_hostkey", XS_Net__SSH2_remote_hostkey, file);
        newXS("Net::SSH2::auth_list", XS_Net__SSH2_auth_list, file);
        newXS("Net::SSH2::auth_ok", XS_Net__SSH2_auth_ok, file);
        newXS("Net::SSH2::auth_password", XS_Net__SSH2_auth_password, file);
#if XSubPPtmpAAAG
        newXS("Net::SSH2::auth_agent", XS_Net__SSH2_auth_agent, file);
#endif
#if XSubPPtmpAAAH
        newXS("Net::SSH2::auth_agent", XS_Net__SSH2_auth_agent, file);
#endif
        newXS("Net::SSH2::auth_publickey", XS_Net__SSH2_auth_publickey, file);
        newXS("Net::SSH2::auth_hostbased", XS_Net__SSH2_auth_hostbased, file);
        newXS("Net::SSH2::auth_keyboard", XS_Net__SSH2_auth_keyboard, file);
#if XSubPPtmpAAAI
        newXS("Net::SSH2::keepalive_config", XS_Net__SSH2_keepalive_config, file);
        newXS("Net::SSH2::keepalive_send", XS_Net__SSH2_keepalive_send, file);
#endif
#if XSubPPtmpAAAJ
        newXS("Net::SSH2::keepalive_config", XS_Net__SSH2_keepalive_config, file);
        newXS("Net::SSH2::keepalive_send", XS_Net__SSH2_keepalive_send, file);
#endif
        newXS("Net::SSH2::channel", XS_Net__SSH2_channel, file);
        newXS("Net::SSH2::_scp_get", XS_Net__SSH2__scp_get, file);
        newXS("Net::SSH2::_scp_put", XS_Net__SSH2__scp_put, file);
        newXS("Net::SSH2::tcpip", XS_Net__SSH2_tcpip, file);
        newXS("Net::SSH2::listen", XS_Net__SSH2_listen, file);
#if XSubPPtmpAAAK
        newXS("Net::SSH2::known_hosts", XS_Net__SSH2_known_hosts, file);
#endif
#if XSubPPtmpAAAL
        newXS("Net::SSH2::known_hosts", XS_Net__SSH2_known_hosts, file);
#endif
        newXS("Net::SSH2::_poll", XS_Net__SSH2__poll, file);
        newXS("Net::SSH2::sftp", XS_Net__SSH2_sftp, file);
        newXS("Net::SSH2::public_key", XS_Net__SSH2_public_key, file);
        newXS("Net::SSH2::Channel::DESTROY", XS_Net__SSH2__Channel_DESTROY, file);
        newXS("Net::SSH2::Channel::session", XS_Net__SSH2__Channel_session, file);
        newXS("Net::SSH2::Channel::setenv", XS_Net__SSH2__Channel_setenv, file);
#if XSubPPtmpAAAM
        newXS("Net::SSH2::Channel::exit_signal", XS_Net__SSH2__Channel_exit_signal, file);
#endif
#if XSubPPtmpAAAN
        newXS("Net::SSH2::Channel::exit_signal", XS_Net__SSH2__Channel_exit_signal, file);
#endif
        newXS("Net::SSH2::Channel::blocking", XS_Net__SSH2__Channel_blocking, file);
        newXS("Net::SSH2::Channel::eof", XS_Net__SSH2__Channel_eof, file);
        newXS("Net::SSH2::Channel::send_eof", XS_Net__SSH2__Channel_send_eof, file);
        newXS("Net::SSH2::Channel::close", XS_Net__SSH2__Channel_close, file);
        newXS("Net::SSH2::Channel::wait_closed", XS_Net__SSH2__Channel_wait_closed, file);
        newXS("Net::SSH2::Channel::exit_status", XS_Net__SSH2__Channel_exit_status, file);
#if XSubPPtmpAAAO
        newXS("Net::SSH2::Channel::pty", XS_Net__SSH2__Channel_pty, file);
        newXS("Net::SSH2::Channel::pty_size", XS_Net__SSH2__Channel_pty_size, file);
#endif
#if XSubPPtmpAAAP
        newXS("Net::SSH2::Channel::pty", XS_Net__SSH2__Channel_pty, file);
        newXS("Net::SSH2::Channel::pty_size", XS_Net__SSH2__Channel_pty_size, file);
#endif
        newXS("Net::SSH2::Channel::process", XS_Net__SSH2__Channel_process, file);
        newXS("Net::SSH2::Channel::ext_data", XS_Net__SSH2__Channel_ext_data, file);
        newXS("Net::SSH2::Channel::read", XS_Net__SSH2__Channel_read, file);
        newXS("Net::SSH2::Channel::write", XS_Net__SSH2__Channel_write, file);
#if XSubPPtmpAAAQ
        newXS("Net::SSH2::Channel::receive_window_adjust", XS_Net__SSH2__Channel_receive_window_adjust, file);
#endif
#if XSubPPtmpAAAR
        newXS("Net::SSH2::Channel::receive_window_adjust", XS_Net__SSH2__Channel_receive_window_adjust, file);
#endif
#if XSubPPtmpAAAS
        newXS("Net::SSH2::Channel::window_write", XS_Net__SSH2__Channel_window_write, file);
        newXS("Net::SSH2::Channel::window_read", XS_Net__SSH2__Channel_window_read, file);
#endif
#if XSubPPtmpAAAT
        newXS("Net::SSH2::Channel::window_write", XS_Net__SSH2__Channel_window_write, file);
        newXS("Net::SSH2::Channel::window_read", XS_Net__SSH2__Channel_window_read, file);
#endif
        newXS("Net::SSH2::Channel::flush", XS_Net__SSH2__Channel_flush, file);
        newXS("Net::SSH2::Listener::DESTROY", XS_Net__SSH2__Listener_DESTROY, file);
        newXS("Net::SSH2::Listener::accept", XS_Net__SSH2__Listener_accept, file);
        newXS("Net::SSH2::SFTP::DESTROY", XS_Net__SSH2__SFTP_DESTROY, file);
        newXS("Net::SSH2::SFTP::session", XS_Net__SSH2__SFTP_session, file);
        newXS("Net::SSH2::SFTP::error", XS_Net__SSH2__SFTP_error, file);
        newXS("Net::SSH2::SFTP::open", XS_Net__SSH2__SFTP_open, file);
        newXS("Net::SSH2::SFTP::opendir", XS_Net__SSH2__SFTP_opendir, file);
        newXS("Net::SSH2::SFTP::unlink", XS_Net__SSH2__SFTP_unlink, file);
        newXS("Net::SSH2::SFTP::rename", XS_Net__SSH2__SFTP_rename, file);
        newXS("Net::SSH2::SFTP::mkdir", XS_Net__SSH2__SFTP_mkdir, file);
        newXS("Net::SSH2::SFTP::rmdir", XS_Net__SSH2__SFTP_rmdir, file);
        newXS("Net::SSH2::SFTP::stat", XS_Net__SSH2__SFTP_stat, file);
        newXS("Net::SSH2::SFTP::setstat", XS_Net__SSH2__SFTP_setstat, file);
        newXS("Net::SSH2::SFTP::symlink", XS_Net__SSH2__SFTP_symlink, file);
        newXS("Net::SSH2::SFTP::readlink", XS_Net__SSH2__SFTP_readlink, file);
        newXS("Net::SSH2::SFTP::realpath", XS_Net__SSH2__SFTP_realpath, file);
        newXS("Net::SSH2::File::DESTROY", XS_Net__SSH2__File_DESTROY, file);
        newXS("Net::SSH2::File::read", XS_Net__SSH2__File_read, file);
        newXS("Net::SSH2::File::write", XS_Net__SSH2__File_write, file);
        newXS("Net::SSH2::File::stat", XS_Net__SSH2__File_stat, file);
        newXS("Net::SSH2::File::setstat", XS_Net__SSH2__File_setstat, file);
        newXS("Net::SSH2::File::seek", XS_Net__SSH2__File_seek, file);
        newXS("Net::SSH2::File::tell", XS_Net__SSH2__File_tell, file);
        newXS("Net::SSH2::Dir::DESTROY", XS_Net__SSH2__Dir_DESTROY, file);
        newXS("Net::SSH2::Dir::read", XS_Net__SSH2__Dir_read, file);
        newXS("Net::SSH2::PublicKey::DESTROY", XS_Net__SSH2__PublicKey_DESTROY, file);
        newXS("Net::SSH2::PublicKey::add", XS_Net__SSH2__PublicKey_add, file);
        newXS("Net::SSH2::PublicKey::remove", XS_Net__SSH2__PublicKey_remove, file);
        newXS("Net::SSH2::PublicKey::fetch", XS_Net__SSH2__PublicKey_fetch, file);
#if XSubPPtmpAAAU
        newXS("Net::SSH2::KnownHosts::DESTROY", XS_Net__SSH2__KnownHosts_DESTROY, file);
        newXS("Net::SSH2::KnownHosts::readfile", XS_Net__SSH2__KnownHosts_readfile, file);
        newXS("Net::SSH2::KnownHosts::writefile", XS_Net__SSH2__KnownHosts_writefile, file);
        newXS("Net::SSH2::KnownHosts::add", XS_Net__SSH2__KnownHosts_add, file);
        newXS("Net::SSH2::KnownHosts::check", XS_Net__SSH2__KnownHosts_check, file);
        newXS("Net::SSH2::KnownHosts::readline", XS_Net__SSH2__KnownHosts_readline, file);
        newXS("Net::SSH2::KnownHosts::writeline", XS_Net__SSH2__KnownHosts_writeline, file);
#endif

    /* Initialisation Section */

#line 778 "SSH2.xs"
{
    MY_CXT_INIT;
#ifdef HAVE_GCRYPT
    gcry_error_t ret;
#ifndef WIN32
    ret = gcry_control(GCRYCTL_SET_THREAD_CBS, &gcry_threads_pthread);
#else
    ret = gcry_control(GCRYCTL_SET_THREAD_CBS, &gcry_threads_pth);
#endif
    if (gcry_err_code(ret) != GPG_ERR_NO_ERROR)
        croak("could not initialize libgcrypt for threads (%d: %s/%s)",
         gcry_err_code(ret),
         gcry_strsource(ret),
         gcry_strerror(ret));

    if (!gcry_check_version(GCRYPT_VERSION))
        croak("libgcrypt version mismatch (needed: %s)", GCRYPT_VERSION);
#else /* OpenSSL */
    openssl_threads_init();
    MY_CXT.global_cb_data = newHV();
    MY_CXT.tid = get_my_thread_id();
    debug("Net::SSH2::BOOT: tid=%d my_perl=0x%p\n", MY_CXT.tid, my_perl);
#endif
}

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
#if XSubPPtmpAAAD
#endif
#if XSubPPtmpAAAE
#endif
#if XSubPPtmpAAAF
#endif
#if XSubPPtmpAAAG
#endif
#if XSubPPtmpAAAH
#endif
#if XSubPPtmpAAAI
#endif
#if XSubPPtmpAAAJ
#endif
#if XSubPPtmpAAAK
#endif
#if XSubPPtmpAAAL
#endif
#if XSubPPtmpAAAM
#endif
#if XSubPPtmpAAAN
#endif
#if XSubPPtmpAAAO
#endif
#if XSubPPtmpAAAP
#endif
#if XSubPPtmpAAAQ
#endif
#if XSubPPtmpAAAR
#endif
#if XSubPPtmpAAAS
#endif
#if XSubPPtmpAAAT
#endif
#if XSubPPtmpAAAU
#endif
#line 5548 "SSH2.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

